<?php
/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: datagrid_detail.php,v 1.1 2001/12/05 13:44:48 ach Exp $ */

include("apl_config.php");

// Global classes

class CDatabase extends CAPLDatabase
{
  function CDatabase()
  {
    CAPLDatabase::CAPLDatabase();
    $this->setHostname(DB_HOSTNAME);
    $this->setUsername(DB_USERNAME);
    $this->setPassword(DB_PASSWORD);
    $this->setDriver(DB_DRIVER);
    $this->setDatabase(DB_DATABASE); 
    $this->setType(DB_TYPE);
  }
}

class CUserSource extends CAPLDBControl
{  
  function CUserSource($Database)
  {
    CAPLDBControl::CAPLDBControl($Database);
    $this->setTable("tblaplgridform1user");
    $this->setPrimaryKey("userid");
    $this->setName("User");
  }
}

// Global Objects

$Database = new CDatabase();
$ActionHandler = new CAPLActionHandler();
$Page = new CAPLPage();

// Detail Form

$Source["Form"] = new CUserSource($Database);
$Source["Form"]->setName("Form");

$Form = new CAPLDataForm($Page);
$Form->setDataControl($Source["Form"]);
$Form->setActionHandler($ActionHandler);
$Form->setName("Form");

$Input["Name"] = new CAPLDataEditBox($Form);
$Input["Name"]->setDataControl($Source["Form"]);
$Input["Name"]->setName("Name");
$Input["Name"]->setCaption("Name");

$Input["Description"] = new CAPLDataTextBox($Form);
$Input["Description"]->setDataControl($Source["Form"]);
$Input["Description"]->setName("Description");
$Input["Description"]->setCaption("Description");

$Button = new CAPLDataButton($Form);
$Button->setAction(APL_ACTION_SAVE);
$Button->setCaption("Save");

$Reset = new CAPLDataButton($Form);
$Reset->setAction(APL_ACTION_CANCEL);
$Reset->setCaption("Cancel");

// Main Grid

$Source["Grid"] = new CUserSource($Database);
$Source["Grid"]->setName("Grid");

$Grid = new CAPLDataGrid($Page);
$Grid->setActionHandler($ActionHandler);
$Grid->setDataControl($Source["Grid"]);
$Grid->createFields(array("Name", "Description"));
$Grid->setActionState(APL_ACTION_STANDARD, APL_STATE_VISIBLE);
$Grid->setName("Grid");

$i = "default";
$Grid->Field["Name"]->setValue($i);
$Grid->Field["Name"]->setState(APL_STATE_HIDDEN);
$Grid->Field["Name"]->setFilter(APL_FILTER_STANDARD, "# = '$i'");

// List / Detail View Logic

$Form->setState(APL_STATE_HIDDEN);
$Grid->setState(APL_STATE_VISIBLE);

function showForm($key)
{
  global $Source, $Form, $Grid, $ActionHandler;

  /*** Move a var to the outside ***/
  $ActionHandler->setVar("Test", $key);

  $Source["Form"]->setPrimaryValue($key);
  $Form->setState(APL_STATE_VISIBLE); 
  $Grid->setState(APL_STATE_HIDDEN);
}

$Grid->setCallback(APL_ACTION_MODIFY_ASK, "showForm");
$Form->setCallback(APL_ACTION_SAVE, "showForm");

// Execution & Page Build

$ActionHandler->execute();
$Page->draw();

?>
