<?php
/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: datagrid_detailtab.php,v 1.1 2001/12/05 13:44:48 ach Exp $ */

include("apl_config.php");

class CDatabase extends CAPLDatabase
{
  function CDatabase()
  {
    CAPLDatabase::CAPLDatabase();
    $this->setHostname(DB_HOSTNAME);
    $this->setUsername(DB_USERNAME);
    $this->setPassword(DB_PASSWORD);
    $this->setDriver(DB_DRIVER);
    $this->setDatabase(DB_DATABASE); 
    $this->setType(DB_TYPE);
  }
}

class CUserSource extends CAPLDBControl
{  
  function CUserSource($Database)
  {
    CAPLDBControl::CAPLDBControl($Database);
    $this->setTable("tblaplgridformtab1user");
    $this->setPrimaryKey("userid");
  }
}

class CGroupSource extends CAPLDBControl
{
  function CGroupSource($Database)
  {
    CAPLDBControl::CAPLDBControl($Database);
    $this->setTable("tblaplgridformtab1group");
    $this->setPrimaryKey("groupid");
  }
}

// Global Objects 

$Database = new CDatabase();
$ActionHandler = new CAPLActionHandler();
$Page = new CAPLPage();

// TabFolder Panel of Detail View, Default Hidden

$TabFolderPanel = new CAPLTabFolderPanel($Page);
$TabFolderPanel->setActionHandler($ActionHandler);
$TabFolderPanel->setState(APL_STATE_HIDDEN);

// First TabFolder, Detail Edit of Grid Entry

$Tab["Form"] = new CAPLTabFolder($TabFolderPanel);
$Tab["Form"]->setCaption("Form");
$Tab["Form"]->setActive();

$Source["Form"] = new CGroupSource($Database);
$Source["Form"]->setName("Form");

$Form = new CAPLDataForm($Tab["Form"]);
$Form->setDataControl($Source["Form"]);
$Form->setActionHandler($ActionHandler);
$Form->setName("Form1");

$Input["Name"] = new CAPLDataEditBox($Form);
$Input["Name"]->setDataControl($Source["Form"]);
$Input["Name"]->setName("Name");
$Input["Name"]->setCaption("Name");

$Input["Description"] = new CAPLDataTextBox($Form);
$Input["Description"]->setDataControl($Source["Form"]);
$Input["Description"]->setName("Description");
$Input["Description"]->setCaption("Description");

$Button = new CAPLDataButton($Form);
$Button->setAction(APL_ACTION_SAVE);
$Button->setCaption("Save");

$Reset = new CAPLDataButton($Form);
$Reset->setAction(APL_ACTION_CANCEL);
$Reset->setCaption("Cancel");

// Second TabFolder, showing a Grid

$Tab["Grid2"] = new CAPLTabFolder($TabFolderPanel);
$Tab["Grid2"]->setCaption("Grid");

$Source["Grid2"] = new CUserSource($Database);
$Source["Grid2"]->setName("Grid2");

$Grid2 = new CAPLDataGrid($Tab["Grid2"]);
$Grid2->setActionHandler($ActionHandler);
$Grid2->setDataControl($Source["Grid2"]);
$Grid2->createFields(array("GroupID", "Name", "Description"));
$Grid2->setActionState(APL_ACTION_STANDARD, APL_STATE_VISIBLE);
$Grid2->setName("Grid2");

$GroupID = $ActionHandler->getVar("GroupID");
$Grid2->Field["GroupID"]->setValue($GroupID);
$Grid2->Field["GroupID"]->setFilter(APL_FILTER_STANDARD, sprintf("# = '%s'", $GroupID)); 
$Grid2->Field["GroupID"]->setState(APL_STATE_HIDDEN);

// Main Grid

$Source["Grid"] = new CGroupSource($Database);
$Source["Grid"]->setName("Grid");

$Grid = new CAPLDataGrid($Page);
$Grid->setActionHandler($ActionHandler);
$Grid->setDataControl($Source["Grid"]);
$Grid->createFields(array("Name", "Description"));
$Grid->setActionState(APL_ACTION_STANDARD, APL_STATE_VISIBLE);
$Grid->setName("Grid1");

// Callback Logic: Show Form

function showForm($key)
{
  global $Source, $Grid, $TabFolderPanel, $ActionHandler;

  $Source["Form"]->setPrimaryValue($key);
  $TabFolderPanel->setState(APL_STATE_VISIBLE); 
  $Grid->setState(APL_STATE_HIDDEN);
  $ActionHandler->setVar("GroupID", $key);
}

$Grid->setCallback(APL_ACTION_MODIFY_ASK, "showForm");
$Form->setCallback(APL_ACTION_SAVE, "showForm");

// Callback Logic: Show TabFolderPanel

function showTabFolderPanel($key)
{
  global $ActionHandler;

  $GroupID = $ActionHandler->getVar("GroupID");
  showForm($GroupID);
}

$TabFolderPanel->setCallback(APL_ACTION_ACTIVATE, "showTabFolderPanel");

$Grid2->setCallback(APL_ACTION_STANDARD, "showTabFolderPanel");
$Grid2->setCallback(APL_ACTION_MISC, "showTabFolderPanel");

// Execution & Page Build

$ActionHandler->execute();
$Page->draw();

?>
