<?php
/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: datagrid_lookup.php,v 1.1 2001/12/05 13:44:48 ach Exp $ */

include("apl_config.php");

class CDatabase extends CAPLDatabase
{
  function CDatabase()
  {
    CAPLDatabase::CAPLDatabase();
    $this->setHostname(DB_HOSTNAME);
    $this->setUsername(DB_USERNAME);
    $this->setPassword(DB_PASSWORD);
    $this->setDriver(DB_DRIVER);
    $this->setDatabase(DB_DATABASE); 
    $this->setType(DB_TYPE);
  }
}

class CUserSource extends CAPLDBControl
{  
  function CUserSource($Database)
  {
    CAPLDBControl::CAPLDBControl($Database);
    $this->setTable("tblapltabfolder1users");
    $this->setPrimaryKey("userid");
    $this->setName("users");
  }
}

class CGroupSource extends CAPLDBControl
{  
  function CGroupSource($Database)
  {
    CAPLDBControl::CAPLDBControl($Database);
    $this->setTable("tblapltabfolder1groups");
    $this->setPrimaryKey("groupid");
    $this->setName("groups");
  }
}

$Database = new CDatabase();
$UserSource = new CUserSource($Database);
$UserSource->setLimit(3);
$GroupSource = new CGroupSource($Database);

$Action = new CAPLActionHandler;
$Page = new CAPLPage;

function activateCallback($key) {
  printf("Callback <b>APL_ACTION_ACTIVATE</b> called with <b>Key $key</b><br><br>");
}

function changeCallback($key) {
  printf("Callback <b>APL_ACTION_CHANGE</b> called with <b>Key $key</b><br><br>");
}

$TabFolderPanel = new CAPLTabFolderPanel($Page);
$TabFolderPanel->setWidth("650");
$TabFolderPanel->setHeight("200");
$TabFolderPanel->setActionHandler($Action);
$TabFolderPanel->setCallback(APL_ACTION_ACTIVATE, "activateCallback");
$TabFolderPanel->setCallback(APL_ACTION_CHANGE, "changeCallback");

// First TabFolder

$Tab0 = new CAPLTabFolder($TabFolderPanel);
$Tab0->setCaption("Users");

$Group0 = new CAPLGroupBox($Tab0);
$Group0->setCaption("UserList");
$Group0->setWidth("500");

$GridUsers = new CAPLDataGrid($Group0);
$GridUsers->setDataControl($UserSource);
$GridUsers->createFields(array("Name","Login","GroupID"));
$GridUsers->setActionHandler($Action);
$GridUsers->Field["Name"]->setLink("page.php","primaryValue", "Value");
$GridUsers->setActionState(APL_ACTION_STANDARD, APL_STATE_VISIBLE);
$GridUsers->setName("Users");

// Adding a lookup

$GroupLookup = new CGroupSource($Database);
$GridUsers->Field["GroupID"]->createLookup($GroupLookup, "Name");
$GridUsers->Field["GroupID"]->Lookup->setOrder();

$ComboBox = new CAPLComboBox;
$ComboBox->addItem("1", "Admin");
$ComboBox->addItem("2", "User");
$ComboBox->addItem("3", "Supervisor"); 
$GridUsers->Field["Login"]->setActionObject($ComboBox);

// Second TabFolder

$Tab1=new CAPLTabFolder($TabFolderPanel);
$Tab1->setCaption("Groups");
$Tab1->setActive();

$GridGroups=new CAPLDataGrid($Tab1);
$GridGroups->setDataControl($GroupSource);
$GridGroups->createFields(array("Name","Description"));
$GridGroups->setActionHandler($Action);
$GridGroups->setActionState(APL_ACTION_STANDARD, APL_STATE_VISIBLE);
$GridGroups->setName("Group");

$Action->execute();
$Page->draw();

?>
