<?php
/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: dataupload.php,v 1.1 2001/12/05 13:44:48 ach Exp $ */

include("apl_config.php");
define("PICTURE_DIR", "/tmp");

class CDatabase extends CAPLDatabase
{
  function CDatabase()
  {
    CAPLDatabase::CAPLDatabase();
    $this->setHostname(DB_HOSTNAME);
    $this->setUsername(DB_USERNAME);
    $this->setPassword(DB_PASSWORD);
    $this->setDriver(DB_DRIVER);
    $this->setDatabase(DB_DATABASE);
    $this->setType(DB_TYPE);
  }
}

class CPictureSource extends CAPLDBControl
{
  function CPictureSource($Database)
  {
    CAPLDBControl::CAPLDBControl($Database);
    $this->setTable("tblaplupload1pictures");
    $this->setPrimaryKey("pictureid");
  }
}

$DB = new CDatabase();
$Data["pictures"] = new CPictureSource($DB);
$Data["pictures"]->setName("pictures");
$Data["grid"] = new CPictureSource($DB);
$Data["grid"]->setName("grid");

$Page = new CAPLPage();
$Action = new CAPLActionHandler();

// create GroupBox for pictureupload-form
$Group = new CAPLGroupBox($Page);
$Group->setCaption("Picture Upload");
$Group->setWidth("400");

// form-initialisation
$Form = new CAPLDataForm($Group);
$Form->setActionHandler($Action);
$Form->setDataControl($Data["pictures"]);
$Form->setEnctype("multipart/form-data");
$Form->setName("picture");

// callback-function, to copy the picture to the destination
function movePicture($key, $field, $value, $subvalue)
{
  if (file_exists($subvalue["tmp_name"])) {
    printf("File <b>%s</b> was uploaded to <b>%s</b><br>", $value, $subvalue["tmp_name"]);

    printf("<pre>");
    var_dump($key);       // $key -> primary key in db
    var_dump($field);     // $field -> fieldname in db
    var_dump($value);     // $value -> picturename
    var_dump($subvalue);  // $subvalue -> array -> $subvalue["name"]=picturename, $subvalue["size"]=picturesize, $subvalue["tmp_name"]=destination, $subvalue["type"]=type of file (.gif, .jpg, .txt, ...)
    printf("</pre>");

    // If the file exists, it can be copied to its destination
    if (copy($subvalue["tmp_name"], PICTURE_DIR."/".$value)) {
      printf("<b>copy ok</b>");
    } else {
      printf("<b>copy failed</b>");
    }
  }
}

// input field and "search"-button to search for the picture on hard-disc
$Input["Upload"] = new CAPLDataUpload($Form);
$Input["Upload"]->setDataControl($Data["pictures"]);
$Input["Upload"]->setName("Path");
$Input["Upload"]->setCaption("Path");
$Input["Upload"]->setCallback(APL_EVENT_ADD_AFTER, "movePicture");
$Input["Upload"]->setCallback(APL_EVENT_MODIFY_AFTER, "movePicture");

// save-button to save the pic-name in the db as a new entry
$Button = new CAPLDataButton($Form);
$Button->setAction(APL_ACTION_SAVE_NEW);
$Button->setCaption("Save");

// create GroupBox for DataGrid
$Group2 = new CAPLGroupBox($Page);
$Group2->setCaption("Uploaded Pictures");
$Group2->setWidth("400");

// create CAPLImage-object to use later as OutputObject in the grid
$Image = new CAPLImage();
$Image->setSource(PICTURE_DIR."/");

// CAPLDataGrid which displays the images
$Grid = new CAPLDataGrid($Group2);
$Grid->setActionHandler($Action);
$Grid->setDataControl($Data["grid"]);
$Grid->createFields(array("Path"));
$Grid->Field["Path"]->setOutputObject($Image);  // here is the above created CAPLImage-object used to display the image, which name is stored in this dbfield
$Grid->setActionState(APL_ACTION_STANDARD, APL_STATE_VISIBLE);

function removePicture($key, $field) {
  global $DB;
  printf("<pre>");
  var_dump($key);
  var_dump($field);
  printf("</pre>");
	
  $DB->connect();
  $sSQL = sprintf("SELECT * FROM tblaplupload1pictures WHERE pictureID='%s'", $key);
  $Result = $DB->openQuery($sSQL);
  while($Result->fetch()) {
    $picname = $Result->get(1);
    $id = $Result->get(0);
  }
  $DB->disconnect();
	
  if (file_exists(PICTURE_DIR."/".$picname)) {
    if(unlink(PICTURE_DIR."/".$picname)) {
      printf("deletion ok");
    } else {
      printf("deletion failed");
    }
  }
}

$Grid->Field["Path"]->setCallback(APL_EVENT_REMOVE_BEFORE, "removePicture");

$Action->execute();
$Page->draw();

?>
