/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: apl_config.h,v 1.57 2002/03/18 21:28:18 ach Exp $ */


#ifndef APL_CONFIG_H
#define APL_CONFIG_H

#include "php_apl_public.h"
#include "apldatabase.h"
#include "apl_ac.h"

#ifdef APL_DEBUG
#define APL_TRACEINPARAM(c,m) for(int IDI=0;IDI<APLG(APL_ICDI);IDI++) cerr << "  "; cerr << "-> apl: " << this << " = " << c << "(" << m << ")" << endl; APLG(APL_ICDI)++;
#define APL_TRACEIN(c) for(int IDI=0;IDI<APLG(APL_ICDI);IDI++) cerr << "  "; cerr << "-> apl: " << this << " = " << c << "()" << endl; APLG(APL_ICDI)++;
#define APL_TRACEVAR(c,x,y) APLG(APL_ICDI)--;for(int IDI=0;IDI<APLG(APL_ICDI);IDI++) cerr << "  "; cerr << "-- apl: " << this << " = " << c << " : " << x << " = " << y << endl;APLG(APL_ICDI)++;
#define APL_TRACEOUTRET(c,r) APLG(APL_ICDI)--; for(int IDI=0;IDI<APLG(APL_ICDI);IDI++) cerr << "  "; cerr << "<- apl: " << this << " = " << c << "=" << r << endl;
#define APL_TRACEOUT(c) APLG(APL_ICDI)--; for(int IDI=0;IDI<APLG(APL_ICDI);IDI++) cerr << "  "; cerr << "<- apl: " << this << " = " << c << endl;
#else
#define APL_TRACEINPARAM(c,m)
#define APL_TRACEIN(c)
#define APL_TRACEVAR(c,x,y)
#define APL_TRACEOUTRET(c,r)
#define APL_TRACEOUT(c)
#endif

enum APL_DATABASES {
  DATABASE_ODBC = SQLXX_ODBC,
  DATABASE_MYSQL = SQLXX_MYSQL,
  DATABASE_POSTGRES = SQLXX_POSTGRES,
  DATABASE_STANDARD,
  DATABASE_NUMBER
};

enum APL_EVENTS {
  EVENT_ADD_BEFORE,
  EVENT_ADD_AFTER,
  EVENT_MODIFY_BEFORE,
  EVENT_MODIFY_AFTER,
  EVENT_REMOVE_BEFORE,
  EVENT_REMOVE_AFTER,
  EVENT_NUMBER
};

enum APL_ACTIONS {
  ACTION_ADD,
  ACTION_ADD_ASK,
  ACTION_MODIFY,
  ACTION_MODIFY_ASK,
  ACTION_REMOVE,
  ACTION_REMOVE_ASK,
  ACTION_SAVE,
  ACTION_SAVE_NEW,
  ACTION_CANCEL,
  ACTION_STANDARD,
  ACTION_MISC,
  ACTION_FILTER,
  ACTION_ORDER,
  ACTION_SKIP,
  ACTION_ACTIVATE,
  ACTION_ACTIVE,
  ACTION_CHANGE,
  ACTION_NUMBER
};

enum APL_CONVERTORS {
  CONVERTOR_OUTPUT,
  CONVERTOR_ACTION,
  CONVERTOR_STORAGE,
  CONVERTOR_NUMBER
};

enum APL_VALIDATORS {
  VALIDATOR_STANDARD,
  VALIDATOR_COLLECTOR,
  VALIDATOR_NUMBER
};

enum APL_FILTER {
  FILTER_STANDARD,
  FILTER_WILDCARD,
  FILTER_NUMBER
};

enum APL_STATES {
  STATE_VISIBLE = (1 << 1),
  STATE_HIDDEN = (1 << 1) + 1,
  STATE_ENABLED = (1 << 2),
  STATE_DISABLED = (1 << 2) + 1,
  STATE_READWRITE = (1 << 3),
  STATE_READONLY = (1 << 3) + 1
};

enum APL_DATACONTROLS {
  DATACONTROL_FETCH,
  DATACONTROL_UPDATE,
  DATACONTROL_ADD,
  DATACONTROL_MODIFY,
  DATACONTROL_REMOVE,
  DATACONTROL_NUMBER
};

enum APL_DATETIMES {
  DATETIME_STANDARD,
  DATETIME_DATE,
  DATETIME_TIME,
  DATETIME_NUMBER
};

enum APL_EDITBOXES {
  EDITBOX_STANDARD,
  EDITBOX_PASSWORD,
  EDITBOX_NUMBER
};

enum APL_CHECKBOXES {
  CHECKBOX_STANDARD,
  CHECKBOX_BOOLEAN,
  CHECKBOX_NUMBER
};

enum APL_BUTTONS {
  BUTTON_STANDARD,
  BUTTON_IMAGE,
  BUTTON_RESET,
  BUTTON_NUMBER
};

enum APL_SHAPES {
  SHAPE_POLYGON,
  SHAPE_RECT,
  SHAPE_CIRCLE
};

#define TEMPLATESUFFIX ".tmpl"
#define TEMPLATETYPE "default"
#define TEMPLATENAME "main"
#define THEME "default"
#define STYLE "default"
#define STYLE_CONF "style.conf"
#define CLASS_CHECKS "1"
#define PRINTF(z,l) zend_write(z,l)
#define ERROR(z,x) zend_error(z,x)

#endif
