/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: aplactionhandler.h,v 1.21 2002/04/01 22:28:25 ach Exp $ */


#ifndef APLACTIONHANDLER_H
#define APLACTIONHANDLER_H

#include <map>
#include <string>
#include <vector>
#include "aplobject.h"
#include "apl_config.h"

typedef std::vector < CAPLObject* > actionobjects;

typedef struct apl_action_data_struct apl_action_data;
typedef std::map < std::string, apl_action_data > apl_action_hash;

struct apl_action_data_struct {
  // Properties
  std::string value;
  apl_action_hash data;
  // Methods
  apl_action_hash getData(void);
  std::vector < std::string > getList(void);
  bool existsKey(const std::string &);
  std::string getKey();
};

class CAPLActionHandler {
  std::map < std::string, std::string > NewActionVars;
  actionobjects ActionObjects;
  std::string sPage;
public:
  CAPLActionHandler() {};
  ~CAPLActionHandler() {};
  
  apl_action_hash data;
  void addActionObject(CAPLObject *);
  void setPage(const std::string &);
  std::string getPage(void);
  bool existsKey(const std::string &);
  apl_action_data getData(const std::string &);

  void setVar(const std::string &, const std::string &);
  void delVar(const std::string &);
  void clearVars(void);
  void clear(void);
  std::map < std::string, std::string > getVars(void);
  bool existsVar(const std::string &);
  void execute();
};

#endif
