/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: aplcombobox.h,v 1.21 2002/04/01 22:28:25 ach Exp $ */


#ifndef APLCOMBOBOX_H
#define APLCOMBOBOX_H

#include <string>
#include "aplformobject.h"

class CAPLComboBoxItem;
typedef std::vector < CAPLComboBoxItem* > comboboxitems;

class CAPLComboBox : public CAPLFormObject {
private:
  bool bMultiple;
  int iSize;
  int compare;
public:
  CAPLComboBox(CAPLObject * = NULL);
  virtual ~CAPLComboBox() {};

  comboboxitems Item;  
  void addComboBoxItem(CAPLComboBoxItem *);
  void setSize(const int);
  void addItem(const std::string &, const std::string & = "", bool = false);
  void setCompare(const int &);
  void setMultiple(const bool &);
  std::string output();
};

class CAPLComboBoxItem : public CAPLFormObject {
private:
  bool bSelected;
  std::string sText;
public:
  CAPLComboBoxItem(CAPLComboBox * Parent);
  virtual ~CAPLComboBoxItem() {};

  void setSelected(const bool = true);
  void setText(const std::string &);
  std::string getText(void);
  std::string output();
};

#endif
