/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: apldatabase.h,v 1.14 2002/04/01 22:28:25 ach Exp $ */


#ifndef APLDATABASE_H
#define APLDATABASE_H
#include <sqlxx.h>
#include <map>
#include "apl_config.h"

class apldatabase_error : public sqlxx::sqlxx_error {
public:
  apldatabase_error(const std::string &what_arg) : sqlxx::sqlxx_error(what_arg) {};
};

class CAPLDatabase : public sqlxx::CSQL {
public:
  CAPLDatabase();
  ~CAPLDatabase() {};
  void setType(const unsigned short, const int = -1);
  void setDriverType(const unsigned short);
  unsigned short getDriverType(void);
  void setDatabaseType(const unsigned short);
  unsigned short getDatabaseType(void);
private:
  unsigned short databaseType;
};

class CAPLDBResult : public sqlxx::CSQLResult {
public:
  CAPLDBResult(sqlxx::CSQL *Database, const int &bufferSize = 1024) : sqlxx::CSQLResult(Database, bufferSize) {};
  ~CAPLDBResult() {};
};



#endif
