/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: apldatadatetime.h,v 1.13 2002/04/01 22:28:25 ach Exp $ */


#ifndef APLDATADATETIME_H
#define APLDATADATETIME_H

#include <string>
#include "apldataformobject.h"
#include "apldatacontrolobject.h"
#include "apldataform.h"
#include "apldatetime.h"

class CAPLDataDateTime : public CAPLDataFormObject {
private:
  CAPLDateTime DateTime;
  int yearBegin, yearEnd;
public:
  CAPLDataDateTime(CAPLObject * = NULL);
  virtual ~CAPLDataDateTime() {};
  
  void setYearRange(const int &, const int & = -1);
  void setYearLimit(const int &, const int &);
  int executeRelayedCollector(apl_action_data *, CAPLActionHandler *);
  void setState(const int);
  void setType(const int);
  std::string output();
  void setCheckBox(const bool & = true);
};

#endif
