/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: apldataform.h,v 1.43 2002/04/01 22:28:25 ach Exp $ */


#ifndef APLDATAFORM_H
#define APLDATAFORM_H

#include <string>
#include <vector>
#include <map>
#include "apldataobject.h"
#include "apldatacontrolobject.h"
#include "aplengine.h"
#include "aplactionhandler.h"
#include "aplhiddenfield.h"
#include "apl_config.h"
#include "aplformcontrolobject.h"

class CAPLDataForm : public CAPLFormControlObject {
private:
  std::vector < CAPLDataControlObject * > DataControls;
  std::map < int, std::string > sMode;
  std::map < int, dataset > ActionHash;
  std::string enctype;

  void executeAction(void);
  bool isActionForm(void);
  void check(void);
  std::string outputForm(void);
  std::string getFormHidden(const std::string &, const std::string &);
  int getActionMode(void);
public:
  CAPLDataForm(CAPLObject * = NULL);
  ~CAPLDataForm() {};

  void setDataControl(CAPLDataControlObject *);
  void addDataControl(CAPLDataControlObject *);
  void setEnctype(const std::string &);
  void execute(void);
  std::string output(void);
};

#endif
