/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: apldataimage.h,v 1.3 2002/04/01 22:28:25 ach Exp $ */


#ifndef APLDATAIMAGE_H
#define APLDATAIMAGE_H

#include <string>
#include "apldataformobject.h"
#include "apldatacontrolobject.h"
#include "apldataform.h"
#include "aplimage.h"

class CAPLDataImage : public CAPLDataFormObject {
private:
  CAPLImage Image;
public:
  CAPLDataImage(CAPLObject * = NULL);
  virtual ~CAPLDataImage() {};
  
  void setSource(const std::string &);
  void setWidth(const std::string &);
  void setHeight(const std::string &);
  void setAlt(const std::string &);
  void setBorder(const int &);
  void setHSpace(const int &);
  void setVSpace(const int &);
  void setAlign(const std::string &);
  void setMap(const std::string &);
  void setState(const int state);
  std::string output();
};

#endif
