/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: apldataset.h,v 1.20 2002/04/01 22:28:25 ach Exp $ */


#ifndef APLDATASET_H
#define APLDATASET_H

#include <vector>
#include "apldataobject.h"
#include "apldatacontrolobject.h"

class CAPLDataSetField;

class CAPLDataSet {
private:
  std::vector < CAPLDataSetField* > DataSetFields;
  CAPLDataControlObject* DataControl;
  bool fetched;
  void check();
public:
  CAPLDataSet();
  
  void addDataSetField(CAPLDataSetField* DataSetField);
  void setDataControl(CAPLDataControlObject *DataControl);
  keylist getList(void);
  int getListSize(void);
  dataset getData(const std::string &key = "");
  void fetch(void);
  std::string add(const std::string &, dataset &);
  void remove(const std::string &);
  std::string modify(const std::string &, dataset &);
};

class CAPLDataSetField : public CAPLDataObject {
  friend class CAPLDataSet;
public:
  CAPLDataSetField(CAPLDataSet* DataSet);
};

#endif
