/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: apldatetime.h,v 1.12 2002/04/01 22:28:25 ach Exp $ */


#ifndef APLDATETIME_H
#define APLDATETIME_H

#include <string>
#include "aplformobject.h"
#include "aplform.h"

class CAPLDateTime: public CAPLFormObject {
private:
  std::string getDateTimeBox(const int, const std::string &, const int &, const int &, const int &);
  int yearBegin, yearEnd;
  int yearLimitBegin, yearLimitEnd;
  int type;
  bool bCheckBox;
public:
  CAPLDateTime(CAPLObject * = NULL);
  virtual ~CAPLDateTime() {};
  
  void setYearRange(const int &, const int & = -1);
  void setYearLimit(const int &, const int &);
  static int makeTimestamp(void *, void*);
  void setType(const int);
  void setCheckBox(const bool & = true);
  std::string output();
};

#endif
