/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: aplengine.h,v 1.32 2002/04/01 22:28:25 ach Exp $ */


#ifndef APLENGINE_H
#define APLENGINE_H

#include <map>
#include <string>
#include <fstream>
#include <iostream>
#include <stdexcept>

#include "aplexecutor.h"
#include "apl_config.h"

class CAPLEngine : public CAPLExecutor {
  int markId;
  std::string getTemplateFile(const std::string &, const std::string &);
  bool existsTemplateFile(const std::string &);
protected:
  std::string templateType;
  std::string templateRoot;
  std::string templateAlias;
  std::string templateName;
  std::string templateAlternative;
  std::string theme, style, styleFile;
public:
  CAPLEngine();
  
  void drawString(const std::string &);

  void setTemplate(const std::string &, const std::string & = "");
  std::string getTemplate(void);
  std::string getAlternativeTemplate(void);

  void setTemplateType(const std::string &);
  std::string getTemplateType(void);

  void drawTemplate(const std::string & = TEMPLATENAME);
  std::string outputTemplate(const std::string & = TEMPLATENAME);

  void setTemplateDir(const std::string &, const std::string & = "");
  std::string getTemplateDir(void);

  void setTemplateAlias(const std::string &);
  std::string getTemplateAlias(void);

  void setTheme(const std::string &);
  std::string getTheme(void);

  void setStyle(const std::string &);
  std::string getStyle(void);

  void processStyleFile(void);
  void setStyleFile(const std::string &);
  std::string getStyleFile(void);

  std::string getThemeDir(const bool & = false);
  std::string getStyleDir(const bool & = false);

  std::string getStyleVar(const std::string &);

  void setMarkId(int);
  int getMarkId(void);
  void newMarkId(void);
};

#endif
