/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: aplexecutor.h,v 1.15 2001/11/21 13:18:15 ach Exp $ */


#ifndef APLEXECUTOR_H
#define APLEXECUTOR_H

#include <string>
#include <map>

typedef std::map < std::string, std::string > vardata;

class CAPLExecutor {
public:
  void setVar(const std::string &, const std::string &);
  void setSlot(const std::string &, const std::string &);
  void setGlobal(const std::string &, const std::string &);
  void setIntern(const std::string &, const std::string &);
  void setStyleVar(const std::string &, const std::string &);
  void setChildren(const std::string &);
  void addChildren(const std::string &);

  const std::string &getVar(const std::string &);
  const std::string &getSlot(const std::string &);
  const std::string &getGlobal(const std::string &);
  const std::string &getIntern(const std::string &);
  const std::string &getStyleVar(const std::string &);
  const std::string &getStyleDir();
  const std::string &getThemeDir();
  const std::string &getChildren();

  static void clearGlobal();

protected:
  vardata Var, Intern, Slot;
  std::string sStyleDir, sThemeDir;
  std::string childrenData;
};

class CAPLExecutorStatic {
public:
  void clearGlobal();
  void clearStyle();
  const std::string &getGlobal(const std::string &);
  void setGlobal(const std::string &, const std::string &);
  const std::string &getStyleVar(const std::string &);
  void setStyleVar(const std::string &, const std::string &);
private:
  vardata Global, Style;
};

#endif
