/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: aplform.h,v 1.21 2002/05/07 13:52:45 ach Exp $ */


#ifndef APLFORM_H
#define APLFORM_H

#include <string>
#include <vector>
#include "aplformobject.h"
#include "aplactionhandler.h"

class CAPLForm: public CAPLFormObject {
private:
  std::string sAction;
  std::string sMethod;
  std::string sEnctype;
  std::string sTarget;
  CAPLActionHandler *ActionHandler;
public:
  CAPLForm(CAPLObject * = NULL);
  virtual ~CAPLForm() {};

  void setAction(const std::string &);
  void setMethod(const std::string &);
  void setEnctype(const std::string &);
  void setActionHandler(CAPLActionHandler *);
  void setTarget(const std::string &);
  std::string output();
};

#endif
