/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: aplformcontrolobject.h,v 1.11 2002/05/10 08:25:29 k Exp $ */


#ifndef APLFORMCONTROLOBJECT_H
#define APLFORMCONTROLOBJECT_H

#include "apldatacontrolobject.h"
#include "aplcallback.h"
#include "apl_config.h"
#include "aplactionhandler.h"

typedef struct {
  const std::string *sKey;
  const std::string *sField;
  const std::string *sValue;
  dataset *mHash;
} apl_form_failure;

typedef struct {
  const std::string *sKey;
  dataset *mHash;
  const std::string *sName;
} apl_formcontrol_action;

class CAPLFormControlObject : public CAPLObject {
public:
  CAPLFormControlObject(CAPLObject * = NULL);
  ~CAPLFormControlObject() {};
  
  void setCallback(int, apl_callback, apl_userdat_dtor, void *);
  void setFailureCallback(int, apl_callback, apl_userdat_dtor, void *);
  void setError(const std::string &);
  std::string getError(void);
  bool getFailure();
  void setFailure(bool);
  void setActionHandler(CAPLActionHandler *ActionHandler);
protected:
  CAPLCallback event[ACTION_NUMBER];
  CAPLCallback failureCallback[ACTION_NUMBER];
  CAPLActionHandler *ActionHandler;
  
  void executeFailureCallback(const std::string &, const std::string &, const std::string &, const std::string &, dataset &, int);
  int executeEvent(int , const std::string *, dataset *);
  std::string sError;
  bool bFailure;
};

#endif
