/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: aplformobject.h,v 1.25 2002/04/01 22:28:25 ach Exp $ */


#ifndef APLFORMOBJECT_H
#define APLFORMOBJECT_H

#include <string>
#include "aplobject.h"
#include "apldatabase.h"
#include "aplcallback.h"
#include "aplactionhandler.h"
#include "apl_config.h"

typedef struct {
  apl_action_data *actionData;
  CAPLActionHandler *actionHandler;
}
apl_formobject_collector;

class CAPLFormObject : public CAPLObject {
private:
  CAPLCallback collector;
protected:
  std::string sCaption;
  apl_action_data *subnode;
public:
  CAPLFormObject(CAPLObject * = NULL);
  virtual ~CAPLFormObject() {};

  void setCaption(const std::string &);
  std::string getCaption(void);
  int executeCollector(apl_action_data *, CAPLActionHandler *);
  void setCollector(apl_callback, apl_userdat_dtor, void *);
};

#endif
