/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: aplimage.h,v 1.14 2002/04/01 22:28:25 ach Exp $ */


#ifndef APLIMAGE_H
#define APLIMAGE_H

#include <string>
#include "aplobject.h"

class CAPLImage: public CAPLObject {
private:
  std::string sAlign;
  std::string sSource;
  std::string sWidth;
  std::string sHeight;
  std::string sAlt;
  std::string sMap;
  int iBorder;
  int iHSpace;
  int iVSpace;
public:
  CAPLImage(CAPLObject * = NULL);
  virtual ~CAPLImage() {};
  
  void setSource(const std::string &sNewSource);
  void setWidth(const std::string &sNewWidth);
  void setHeight(const std::string &sNewHeight);
  void setAlt(const std::string &sNewAlt);
  void setBorder(const int &sNewBorder);
  void setHSpace(const int &iNewHSpace);
  void setVSpace(const int &iNewVSpace);
  void setAlign(const std::string &sNewAlign);
  void setMap(const std::string &sNewMap);
  std::string output();
};

#endif
