/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: aplmap.h,v 1.8 2002/04/01 22:28:26 ach Exp $ */


#ifndef APLMAP_H
#define APLMAP_H

#include <string>
#include <vector>
#include "aplobject.h"
#include "aplactionhandler.h"
#include "aplhyperlink.h"
#include "aplquerystring.h"

class CAPLMap: public CAPLObject {
  friend class CAPLMapArea;
private:
  std::string sName;
  CAPLActionHandler *ActionHandler;
public:
  CAPLMap(CAPLObject * = NULL);
  virtual ~CAPLMap(void);
  
  void setName(const std::string &);
  std::string &getName(void);
  std::string output();
  void setActionHandler(CAPLActionHandler *);
};

class CAPLMapArea: public CAPLObject, public CAPLQueryString {
private:
  long iShape;
  std::string sTarget;
  std::string sLink;
  std::string sAlt;
  std::string sTitle;
  std::vector < long > vCoords;
public:
  CAPLMapArea(CAPLMap * Parent);
  virtual ~CAPLMapArea(void);
  
  void setShape(const long);
  void setCoords(std::vector < long > &);
  void setLink(const std::string &);
  void setTarget(const std::string &);
  void setAlt(const std::string &);
  void setTitle(const std::string &);
  long getShape(void);
  std::string &getLink(void);
  std::string &getTarget(void);
  std::string &getAlt(void);
  std::string &getTitle(void);
  std::vector < long > &getCoords(void);
  std::string output();
};

#endif
