/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: aploplist.h,v 1.17 2002/03/17 13:23:47 ach Exp $ */


#ifndef APLOPLIST_H
#define APLOPLIST_H

#include <string>
#include <vector>

enum {
  OP_INVALID,
  OP_VAR,
  OP_SLOT,
  OP_INTERN,
  OP_THEMEDIR,
  OP_THEME,
  OP_STYLEDIR,
  OP_STYLE,
  OP_STRING,
  OP_GLOBAL,
  OP_NEWLINE,
  OP_CHILDREN
};

class CAPLOp;
class CAPLExecutor;

class CAPLOpList {
public:
  CAPLOpList(const std::string &filename);
  std::string execute(CAPLExecutor *);
  void handle_op(int op, const char *arg1 = NULL, size_t arg1_len = 0);
private:
  std::vector < CAPLOp* > ops;
  int last_op;
};

#endif
