/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: apltabfolder.h,v 1.20 2002/04/01 22:28:26 ach Exp $ */


#ifndef APLTABFOLDER_H
#define APLTABFOLDER_H

#include <string>
#include <vector>
#include "aplobject.h"
#include "aplactionhandler.h"
#include "aplcallback.h"

typedef struct {
  const std::string *key;
}
apl_tabfolder_action;

class CAPLTabFolder;

class CAPLTabFolderPanel: public CAPLObject {
  friend class CAPLTabFolder;
public:
  CAPLTabFolderPanel(CAPLObject * = NULL);
  void addTabFolder(CAPLTabFolder* TabFolder);
  virtual ~CAPLTabFolderPanel() {};
  
  void setWidth(const std::string &sNewWidth);
  std::string getWidth(void);
  void setHeight(const std::string &sNewHeight);
  std::string getHeight(void);
  void setCaption(const std::string &sNewCaption);
  std::string output(void);
  void setActionHandler(CAPLActionHandler* ActionHandler);
  void execute(void);
  void setCallback(int , apl_callback, apl_userdat_dtor, void *data);
  int executeEvent(int type, const std::string *);
  void setActive(const bool & = true);
private:
  std::vector < CAPLTabFolder* > TabFolders;
  std::string sWidth, sHeight, sCaption;
  bool isTabFolderPanel(void);
  CAPLCallback event[ACTION_NUMBER];
protected:
  CAPLActionHandler* ActionHandler;
  std::string oldTab;
};

class CAPLTabFolder: public CAPLObject {
private:
  void ctor(void);
  std::string sCaption;
  std::string sLink;
  bool bActive;
  CAPLTabFolderPanel * TabFolderPanel;
public:
  CAPLTabFolder(CAPLTabFolderPanel * Parent);
  virtual ~CAPLTabFolder() {};
  
  void setCaption(const std::string &);
  void setLink(const std::string &);
  void setActive(const bool & = true);
  bool isActive(void);
  std::string outputCaption();
  std::string outputBody();
};

#endif
