/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: apltext.h,v 1.19 2002/04/01 22:28:26 ach Exp $ */


#ifndef APLTEXT_H
#define APLTEXT_H

#include <string>
#include "aplobject.h"
#include "aplformobject.h"

class CAPLText: public CAPLFormObject {
private:
  std::string sText;
  std::string sCaption;
public:
  CAPLText(CAPLObject * = NULL);
  virtual ~CAPLText() {};
  
  void setCaption(const std::string &);
  void setText(const std::string &);
  std::string output();
};

std::string APLBold(const std::string &);
std::string APLUnderline(const std::string &);
std::string APLItalic(const std::string &);
std::string APLStrike(const std::string &);
std::string APLHeadline(const std::string &, const int = 3);
std::string APLHyperLink(const std::string &, const std::string & = "", const std::string & = "");

std::string APLBreak(const std::string & = "");
std::string APLWordBreak(void);
std::string APLNoBreak(const std::string &);

#endif
