/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: apltreemenu.h,v 1.15 2002/04/01 22:28:26 ach Exp $ */


#ifndef APLTREEMENU_H
#define APLTREEMENU_H

#include <string>
#include "aplobject.h"
#include "aplquerystring.h"
#include "aplactionhandler.h"
#include "aplcallback.h"

typedef struct {
  const std::string *key;
}
apl_treemenu_action;

class CAPLTreeMenu;
class CAPLTreeMenuItem;
typedef std::vector < CAPLTreeMenuItem* > treemenuitems;

class CAPLTreeMenuItem: public CAPLObject {
protected:
  CAPLTreeMenuItem *Parent;
  std::string sText;
  std::string sLink;
  std::string sImage;
  std::string sTarget;
  bool bActive;
public:
  CAPLTreeMenuItem(CAPLTreeMenuItem * = NULL);
  virtual ~CAPLTreeMenuItem() {};
  
  treemenuitems Items;
  void addItem(CAPLTreeMenuItem *);
  void setTarget(const std::string &);
  std::string getTarget(void);
  void setText(const std::string &);
  void setLink(const std::string &);
  void setImage(const std::string &);
  void setActive(const bool bActive = true, const bool onlyParents = false);
  std::string outputItems(const int iLevel = 0, CAPLActionHandler *ActionHandler = NULL, CAPLTreeMenu *TopItem = NULL, const std::string & = "");
};

class CAPLTreeMenu: public CAPLTreeMenuItem {
private:
  std::string sTitle;
  CAPLActionHandler *ActionHandler;
  void setInactive(std::vector < CAPLTreeMenuItem* > );
  void setActionActive(std::vector < CAPLTreeMenuItem* > , const std::string &, const bool &);
  CAPLCallback event[ACTION_NUMBER];
public:
  CAPLTreeMenu(CAPLObject* Parent = NULL);
  virtual ~CAPLTreeMenu() {};
  
  void setCaption(const std::string &);
  void setActionHandler(CAPLActionHandler *);
  void execute();
  std::string output();
  void setCallback(int , apl_callback, apl_userdat_dtor, void *data);
  int executeEvent(int type, const std::string *);
  std::string oldItem;
  std::string item;
};

#endif
