/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: php_apl.h,v 1.77 2001/11/21 13:18:15 ach Exp $ */


#ifndef PHP_APL_H
#define PHP_APL_H

#include <vector>
#include <string>
#include <stdexcept>

#include "php_apl_public.h"

ZEND_FUNCTION(APLBold);
ZEND_FUNCTION(APLUnderline);
ZEND_FUNCTION(APLStrike);
ZEND_FUNCTION(APLHeadline);
ZEND_FUNCTION(APLItalic);
ZEND_FUNCTION(APLHyperLink);
ZEND_FUNCTION(APLBreak);
ZEND_FUNCTION(APLNoBreak);
ZEND_FUNCTION(APLWordBreak);

#include "php_if_le_list.h"

// Do NOT use this macro, if you pass NULL as the second parameter

#if ZEND_MODULE_API_NO < 20001214
#define apl_call_user_function(a,objptr,b,c,d,e) call_user_function(a,*objptr,b,c,d,e)
#else
#define apl_call_user_function call_user_function
#endif

#if ZEND_MODULE_API_NO < 20001222
#define zend_hash_get_current_key_old zend_hash_get_current_key
#else
#define zend_hash_get_current_key_old(a,b,c) zend_hash_get_current_key(a,b,c,1)
#endif

void aplAssertClass(const zval *this_ptr, const std::string &param, int argc, ...);
std::vector < std::string > &convertToStringVector(HashTable *ht);
std::vector < long > &convertToLongVector(HashTable *ht);
std::vector < bool > &convertToBoolVector(HashTable *ht);
std::vector < double > &convertToDoubleVector(HashTable *ht);
void aplCallMethod(zval **object, const char *fname, int argc, ...);
bool aplIsClass(const zval *this_ptr, int argc, ...);
void *aplGetClass(const zval *this_ptr, const char *identifier = "this");
void *aplGetClassEx(const zval *this_ptr, const char *identifier, const std::string &param, int argc, ...);
zend_class_entry *aplGetClassEntry(char *name);

#define CATCH_ERROR_BEGIN() try {
#define CATCH_ERROR_END() } catch(runtime_error E) { zend_error(E_ERROR,E.what());} \
catch(...) { zend_error(E_ERROR,"Unknown exception"); }

#endif
