/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: php_apl_calls.h,v 1.25 2002/05/10 08:25:29 k Exp $ */


#ifndef PHP_APL_CALLS_H
#define PHP_APL_CALLS_H

extern "C" {
# include "Zend/zend_API.h"
}

#include <string>
#include <map>
#include "aplactionhandler.h"
#include "apldatacontrolobject.h"

typedef struct {
  zval *func;
}
apl_php_callback_t;

typedef struct {
  zval *func;
  zval *arg1;
}
apl_php_callback_arg_t;

void aplPrependDocumentRoot(const char *s, size_t len, std::string *result);
void aplCreateArguments(int n, zval **argv);
void aplDestroyArguments(int n, zval **argv);
void aplCallbackDestructor(void *dummy);
std::string * aplCallHandlerString(zval *func, int argc, zval **argv);
int aplCallHandler(zval *func, int argc, zval **argv, std::string **retString = NULL);

int aplCallHandlerEvent(zval *func, const std::string *key, dataset *hash);
int aplCallHandlerDataObject(zval *func, const std::string *key, const std::string *field, const std::string *value, dataset *hash, apl_action_data *action = NULL);

ZEND_NAMED_FUNCTION(aplSetValidator);
ZEND_NAMED_FUNCTION(aplSetConvertor);
ZEND_NAMED_FUNCTION(aplSetDataObjectCallback);
ZEND_NAMED_FUNCTION(aplSetFailureCallback);
ZEND_NAMED_FUNCTION(aplSetActionCallback);
ZEND_NAMED_FUNCTION(aplSetTemplateDir);

#endif
