/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: php_apl_public.h,v 1.21 2002/03/29 22:51:25 ach Exp $ */



#ifndef PHP_APL_PUBLIC_H
#define PHP_APL_PUBLIC_H

#include <string>

extern "C" {

  /* We are not interested in anything C++ related in Zend, so
     undefine __cplusplus to avoid problems in PHP 4.0.6 and earlier */

# if __GNUC__ - 0 > 2
# undef __cplusplus
# endif 
# include "zend_API.h"

# if __GNUC__ - 0 > 2
# define __cplusplus
# endif 
}


#ifndef Z_OBJPROP_P
#define Z_OBJPROP_P(val) (val)->value.obj.properties
#endif

#ifndef Z_OBJCE_P
#define Z_OBJCE_P(val) (val)->value.obj.ce
#endif

#ifndef Z_ARRVAL_P
#define Z_ARRVAL_P(val) (val)->value.ht
#endif

#ifndef Z_ARRVAL_PP
#define Z_ARRVAL_PP(val) Z_ARRVAL_P(*(val))
#endif

ZEND_BEGIN_MODULE_GLOBALS(apl)
std::string sTemplateRoot, sTemplateAlias, sTemplateType, sTheme, sStyle;
std::string styleFile;
long lClassChecks;
int iUniqueName;
int APL_ICDI;
ZEND_END_MODULE_GLOBALS(apl)

#ifdef ZTS
#define APLG(v) (apl_globals->v)
#define APLLS_FETCH() zend_apl_globals *apl_globals = ts_resource(apl_globals_id)
#define APLG_DECLARE ts_rsrc_id apl_globals_id
#else
#define APLG(v) (apl_globals.v)
#define APLLS_FETCH()
#define APLG_DECLARE zend_apl_globals apl_globals
#endif

extern APLG_DECLARE;

#endif
