/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: apl.cpp,v 1.13 2001/11/21 13:18:16 ach Exp $ */


#include "apl.h"
#include "apl_config.h"
#include "apl_ac.h"
#include "aplengine.h"

using namespace std;

CAPL::CAPL() {}


CAPL::~CAPL() {}


string CAPL::getTheme(void) {
  CAPLEngine Engine;

  return Engine.getTheme();
}

string CAPL::getStyle(void) {
  CAPLEngine Engine;

  return Engine.getStyle();
}

string CAPL::getTemplateDir(void) {
  CAPLEngine Engine;

  return Engine.getTemplateDir();
}

string CAPL::getTemplateAlias(void) {
  CAPLEngine Engine;

  return Engine.getTemplateAlias();
}

string CAPL::getTemplateType(void) {
  CAPLEngine Engine;

  return Engine.getTemplateType();
}

string CAPL::getStyleFile(void) {
  CAPLEngine Engine;

  return Engine.getStyleFile();
}

string CAPL::getVersion(void) {
  return APL_VERSION;
}

string CAPL::getRelease(void) {
  return APL_RELEASE;
}

string CAPL::getThemeDir(void) {
  CAPLEngine Engine;

  return Engine.getThemeDir();
}

string CAPL::getStyleDir(void) {
  CAPLEngine Engine;

  return Engine.getStyleDir();
}

void CAPL::setStyleVar(const string &key, const string &val) {
  CAPLEngine Engine;

  Engine.setStyleVar(key, val);
}

string CAPL::getStyleVar(const string &key) {
  CAPLEngine Engine;

  return Engine.getStyleVar(key);
}

void CAPL::setGlobal(const string &key, const string &val) {
  CAPLEngine Engine;

  Engine.setGlobal(key, val);
}

string CAPL::getGlobal(const string &key) {
  CAPLEngine Engine;

  return Engine.getGlobal(key);
}

