/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: aplactionhandler.cpp,v 1.19 2001/12/23 12:34:39 ach Exp $ */


#include "aplactionhandler.h"
#include "aplengine.h"

using namespace std;

apl_action_hash apl_action_data_struct::getData(void) {
  return data;
}

vector < string >  apl_action_data_struct::getList(void) {
  vector < string > vTmpList;
  for (apl_action_hash::iterator I = data.begin(); I != data.end(); I++) {
    vTmpList.push_back((*I).first);
  }
  return vTmpList;
}

bool apl_action_data_struct::existsKey(const string &sKey) {
  if (data.count(sKey))
    return true;
  else
    return false;
}

string apl_action_data_struct::getKey(void) {
  string sReturn = "";
  if (data.size()) {
    apl_action_hash::iterator I = data.begin();
    sReturn = (*I).first;
  }
  return sReturn;
}

void CAPLActionHandler::setPage(const string &sPage) {
  this->sPage = sPage;
}

string CAPLActionHandler::getPage(void) {
  return sPage;
}

map < string, string > CAPLActionHandler::getVars(void) {
  return NewActionVars;
}

void CAPLActionHandler::setVar(const string &sKey, const string &sValue) {
  this->NewActionVars[sKey] = sValue;
  data[sKey].value = sValue;
}

void CAPLActionHandler::delVar(const string &sKey) {
  this->NewActionVars.erase(sKey);
  data.erase(sKey);
}

bool CAPLActionHandler::existsVar(const string &sVar) {
  if (data.count(sVar))
    return true;
  else
    return false;
}

void CAPLActionHandler::clearVars(void) {
  this->NewActionVars.clear();
}

void CAPLActionHandler::clear(void) {
  clearVars();
}

void CAPLActionHandler::addActionObject(CAPLObject* ActionObject) {
  ActionObjects.push_back(ActionObject);
}

bool CAPLActionHandler::existsKey(const string &sKey) {
  if (data.count(sKey))
    return true;
  else
    return false;
}

apl_action_data CAPLActionHandler::getData(const string &sKey) {
  return data[sKey];
}

void CAPLActionHandler::execute(void) {
  for (unsigned int i = 0; i < ActionObjects.size(); i++) ActionObjects[i]->execute();
}
