/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: aplcachedstyle.cpp,v 1.8 2002/09/24 15:04:21 k Exp $ */


#include "aplcachedstyle.h"
#include "aplsdf.h"
#include <fstream>
#include <sys/stat.h>
#include <unistd.h>
#include <stdexcept>

using namespace std;

CAPLCachedStyle::CAPLCachedStyle(const string &sFilename) {
  struct stat sbuf;
  ifstream input;

  if (stat(sFilename.c_str(), &sbuf) == 0) {

    filename = sFilename;
    last_changed = sbuf.st_mtime;
    input.open(filename.c_str());
    aplScanSDF(&input, arrayData);
  }
}

bool CAPLCachedStyle::isRecent(void) {
  struct stat sbuf;

  if (stat(filename.c_str(), &sbuf) == -1)
    return false;

  if (sbuf.st_mtime != last_changed)
    return false;
  return true;
}

void CAPLCachedStyle::mergeArray(map < string, string > &target) {
  for (map < string, string > ::iterator i = arrayData.begin(); i != arrayData.end(); i++) {
    target[i->first] = i->second;
  }
}
