/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: aplcallback.cpp,v 1.6 2001/11/21 13:18:16 ach Exp $ */


#include "aplcallback.h"

using namespace std;

CAPLCallback::CAPLCallback() {
  func = 0;
}

CAPLCallback::~CAPLCallback() {
  if (func && dtor) dtor(userdat);
}

void CAPLCallback::setCallback(apl_callback func, apl_userdat_dtor dtor, void *userdat) {
  // Destroy previous setting
  if (this->func && this->dtor)
    this->dtor(this->userdat);

  this->func = func;
  this->dtor = dtor;
  this->userdat = userdat;
}

int CAPLCallback::execute(void *data) {
  int ret = 0;

  if (func) ret = func(userdat, data);
  return ret;
}
