/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: apldatabutton.cpp,v 1.29 2002/09/24 15:04:21 k Exp $ */


#include "apldatabutton.h"

using namespace std;

CAPLDataButton::CAPLDataButton(CAPLObject* Parent) : CAPLDataFormObject(Parent) {
  Button.setTemplate("databutton", "button");
}

void CAPLDataButton::setAction(const int &iNewMode) {
  iMode = iNewMode;
}

void CAPLDataButton::setType(const int type) {
  Button.setType(type);
}

void CAPLDataButton::setImage(const string &imgSrc, const string &imgAlt) {
  Button.setImage(imgSrc, imgAlt);
}

void CAPLDataButton::setWidth(const string &sWidth) {
  Button.setWidth(sWidth);
}

void CAPLDataButton::setHeight(const string &sHeight) {
  Button.setHeight(sHeight);
}

void CAPLDataButton::setBorder(const int iBorder) {
  Button.setBorder(iBorder);
}

void CAPLDataButton::setState(const int state) {
  Button.setState(state);
  CAPLDataFormObject::setState(state);
}

string CAPLDataButton::output() {
  string output = "";

  if (getState() & STATE_VISIBLE) {
    switch (iMode) {
    case ACTION_SAVE:
      Button.setName("APLFormSave");
      break;
    case ACTION_SAVE_NEW:
      Button.setName("APLFormSaveNew");
      break;
    case ACTION_CANCEL:
      Button.setName("APLFormCancel");
      break;
    case ACTION_REMOVE:
      Button.setName("APLFormRemove");
      break;
    default:
      Button.setName("APLFormCancel");
      break;
    }
    Button.setTemplateType(templateType);
    Button.setValue(sCaption);
    output += Button.output();
  }

  return output;
}
