/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: apldatacheckbox.cpp,v 1.33 2002/09/24 15:04:21 k Exp $ */


#include "apldatacheckbox.h"
#include "aplhiddenfield.h"

using namespace std;

CAPLDataCheckBox::CAPLDataCheckBox(CAPLObject* Parent) : CAPLDataFormObject(Parent) {
  CheckBox.setTemplate("datacheckbox", "checkbox");
  CheckBox.setType(CHECKBOX_BOOLEAN);
}

void CAPLDataCheckBox::setChecked(const bool &bChecked = true) {
  CheckBox.setChecked(bChecked);
}

void CAPLDataCheckBox::setState(const int state) {
  CheckBox.setState(state);
  CAPLDataFormObject::setState(state);
}

string CAPLDataCheckBox::output() {
  string output = "";

  check("CAPLDataCheckBox");
  if (getState() & STATE_VISIBLE) {
    CheckBox.setName("Data[" + DataControl->getName() + "][" + getName() + "]");
    CheckBox.setValue(prepareValue());
    CheckBox.setCaption(sCaption);
    CheckBox.setTemplateType(templateType);
    
    output += CheckBox.output();
  }

  return output;
}
