/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: apldatacombobox.cpp,v 1.38 2002/09/24 15:04:21 k Exp $ */


#include "apldatacombobox.h"

using namespace std;

CAPLDataComboBox::CAPLDataComboBox(CAPLObject* Parent) : CAPLDataFormObject(Parent) {
  ComboBox.setTemplate("datacombobox", "combobox");
}

void CAPLDataComboBox::setSize(const int &size) {
  ComboBox.setSize(size);
}

void CAPLDataComboBox::addItem(const string &value, const string &text) {
  ComboBox.addItem(value, text);
}

void CAPLDataComboBox::setState(const int state) {
  ComboBox.setState(state);
  CAPLDataFormObject::setState(state);
}

string CAPLDataComboBox::output() {
  string output = "";

  check("CAPLDataComboBox");
  if (getState() & STATE_VISIBLE) {
    string value = prepareValue();

    if (DataLookup != NULL) {
      keylist List = DataLookup->getList();

      for (unsigned int i = 0; i < List.size(); i++) {
        ComboBox.addItem(List[i], DataLookup->getData(List[i]));
      }
      // Since DataLookup works with JOINS on the DB, we need to compare the Text instead of the values
      if (!DataControl->getError().length())
        ComboBox.setCompare(1);
    }

    

    ComboBox.setValue(value);
    ComboBox.setTemplateType(templateType);
    ComboBox.setName("Data[" + DataControl->getName() + "][" + getName() + "]");
    ComboBox.setCaption(sCaption);
    output += ComboBox.output();
  }

  return output;
}
