/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: apldatadatetime.cpp,v 1.23 2002/09/24 15:04:21 k Exp $ */


#include "apldatadatetime.h"

using namespace std;

CAPLDataDateTime::CAPLDataDateTime(CAPLObject* Parent) : CAPLDataFormObject(Parent) {
  DateTime.setTemplate("datadatetime", "datetime");
}

int CAPLDataDateTime::executeRelayedCollector(apl_action_data *data, CAPLActionHandler *handler) {
  subnode = data;
  return DateTime.executeCollector(data, handler);
}

void CAPLDataDateTime::setYearRange(const int &start, const int &stop) {
  DateTime.setYearRange(start, stop);
}

void CAPLDataDateTime::setYearLimit(const int &start, const int &stop) {
  DateTime.setYearLimit(start, stop);
}

void CAPLDataDateTime::setState(const int state) {
  DateTime.setState(state);
  CAPLDataFormObject::setState(state);
}

void CAPLDataDateTime::setType(const int type) {
  DateTime.setType(type);
}

void CAPLDataDateTime::setCheckBox(const bool &bCheckBox) {
  DateTime.setCheckBox(bCheckBox);
}

string CAPLDataDateTime::output() {
  string output = "";

  check("CAPLDataDateTime");
  if (getState() & STATE_VISIBLE) {
    DateTime.setName("Data[" + DataControl->getName() + "][" + getName() + "]");
    DateTime.setValue(prepareValue());
    DateTime.setTemplateType(templateType);
    DateTime.setCaption(sCaption);
    output += DateTime.output();
  }

  return output;
}
