/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: apldataeditbox.cpp,v 1.32 2002/09/24 15:04:21 k Exp $ */


#include "apldataeditbox.h"

using namespace std;

CAPLDataEditBox::CAPLDataEditBox(CAPLObject* Parent) : CAPLDataFormObject(Parent) {
  EditBox.setTemplate("dataeditbox", "editbox");
}

void CAPLDataEditBox::setSize(const int &size) {
  EditBox.setSize(size);
}

void CAPLDataEditBox::setMaxLength(const int &maxLength) {
  EditBox.setMaxLength(maxLength);
}

void CAPLDataEditBox::setType(const int type) {
  EditBox.setType(type);
}

void CAPLDataEditBox::setState(const int state) {
  EditBox.setState(state);
  CAPLDataFormObject::setState(state);
}

string CAPLDataEditBox::output() {
  string output = "";

  check("CAPLDataEditBox");
  if (getState() & STATE_VISIBLE) {
    EditBox.setName("Data[" + DataControl->getName() + "][" + getName() + "]");
    EditBox.setValue(prepareValue());
    EditBox.setCaption(sCaption);
    EditBox.setTemplateType(templateType);
    output += EditBox.output();
  }

  return output;
}
