/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: apldatahiddenfield.cpp,v 1.21 2002/09/24 15:04:21 k Exp $ */


#include "apldatahiddenfield.h"
using namespace std;

CAPLDataHiddenField::CAPLDataHiddenField(CAPLObject* Parent) : CAPLDataFormObject(Parent) {
  HiddenField.setTemplate("datahiddenfield", "hiddenfield");
}

void CAPLDataHiddenField::setState(const int state) {
  HiddenField.setState(state);
  CAPLDataFormObject::setState(state);
}

string CAPLDataHiddenField::output() {
  string output = "";

  check("CAPLDataHiddenField");
  if (getState() & STATE_VISIBLE) {
    HiddenField.setName("Data[" + DataControl->getName() + "][" + getName() + "]");
    HiddenField.setValue(prepareValue());
    HiddenField.setTemplateType(templateType);
    output += HiddenField.output();
  }

  return output;
}
