/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: apldataimage.cpp,v 1.5 2002/09/24 15:04:21 k Exp $ */


#include "apldataimage.h"

using namespace std;

CAPLDataImage::CAPLDataImage(CAPLObject* Parent) : CAPLDataFormObject(Parent) {
  Image.setTemplate("dataimage", "image");
}

void CAPLDataImage::setSource(const string &sSource) {
  Image.setSource(sSource);
}

void CAPLDataImage::setWidth(const string &sWidth) {
  Image.setWidth(sWidth);
}

void CAPLDataImage::setHeight(const string &sHeight) {
  Image.setHeight(sHeight);
}

void CAPLDataImage::setAlt(const string &sAlt) {
  Image.setAlt(sAlt);
}

void CAPLDataImage::setBorder(const int &sBorder) {
  Image.setBorder(sBorder);
}

void CAPLDataImage::setHSpace(const int &iHSpace) {
  Image.setHSpace(iHSpace);
}

void CAPLDataImage::setVSpace(const int &iVSpace) {
  Image.setHSpace(iVSpace);
}

void CAPLDataImage::setAlign(const string &sAlign) {
  Image.setAlign(sAlign);
}

void CAPLDataImage::setMap(const string &sMap) {
  Image.setMap(sMap);
}

void CAPLDataImage::setState(const int state) {
  Image.setState(state);
  CAPLDataFormObject::setState(state);
}

string CAPLDataImage::output() {
  string output = "";

  check("CAPLDataImage");
  if (getState() & STATE_VISIBLE) {
    string sTmp = prepareValue();
    if (sTmp.length()) {
      Image.setValue(sTmp);
      Image.setTemplateType(templateType);
      output += Image.output();
    }
  }

  return output;
}
