/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: apldatatextbox.cpp,v 1.25 2002/09/24 15:04:21 k Exp $ */


#include "apldatatextbox.h"

using namespace std;

CAPLDataTextBox::CAPLDataTextBox(CAPLObject* Parent) : CAPLDataFormObject(Parent) {
  iRows = iCols = -1;
  TextBox.setTemplate("datatextbox", "textbox");
}

void CAPLDataTextBox::setRows(const int &iNewRows) {
  TextBox.setRows(iNewRows);
}

void CAPLDataTextBox::setCols(const int &iNewCols) {
  TextBox.setCols(iNewCols);
}

void CAPLDataTextBox::setState(const int state) {
  TextBox.setState(state);
  CAPLDataFormObject::setState(state);
}

string CAPLDataTextBox::output() {
  string output = "";

  check("CAPLDataTextBox");
  if (getState() & STATE_VISIBLE) {
    TextBox.setName("Data[" + DataControl->getName() + "][" + getName() + "]");
    TextBox.setValue(prepareValue());
    TextBox.setCaption(sCaption);
    TextBox.setTemplateType(templateType);
    output += TextBox.output();
  }

  return output;
}
