/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: apldataupload.cpp,v 1.20 2002/09/24 15:04:21 k Exp $ */


#include "apldataupload.h"

using namespace std;

CAPLDataUpload::CAPLDataUpload(CAPLObject* Parent) : CAPLDataFormObject(Parent) {
  Upload.setTemplate("dataupload", "upload");
}

int CAPLDataUpload::executeRelayedCollector(apl_action_data *data, CAPLActionHandler *handler) {
  subnode = data;
  return Upload.executeCollector(data, handler);
}

void CAPLDataUpload::setSize(const int &size) {
  Upload.setSize(size);
}

void CAPLDataUpload::setAccept(const string &accept) {
  Upload.setAccept(accept);
}

void CAPLDataUpload::setState(const int state) {
  Upload.setState(state);
  CAPLDataFormObject::setState(state);
}

string CAPLDataUpload::output() {
  string output = "";

  check("CAPLDataUpload");
  if (getState() & STATE_VISIBLE) {
    Upload.setName("Data[" + DataControl->getName() + "][" + getName() + "]");
    Upload.setValue(prepareValue());
    Upload.setCaption(sCaption);
    Upload.setTemplateType(templateType);
    output = Upload.output();
  }

  return output;
}
