/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: apleditbox.cpp,v 1.32 2002/09/24 15:04:21 k Exp $ */


#include "apleditbox.h"

using namespace strutilsxx;
using namespace std;

CAPLEditBox::CAPLEditBox(CAPLObject* Parent) : CAPLFormObject(Parent) {
  iSize = -1;
  iMaxLength = -1;
  type = EDITBOX_STANDARD;
  setTemplate("editbox");
}

void CAPLEditBox::setSize(const int &iNewSize) {
  iSize = iNewSize;
}

void CAPLEditBox::setMaxLength(const int &iNewMaxLength) {
  iMaxLength = iNewMaxLength;
}

void CAPLEditBox::setType(const int type) {
  this->type = type;
}

string CAPLEditBox::output() {
  string output = "";
  if (getState() & STATE_VISIBLE) {
    string sParams = "";

    prepare();
    switch (type) {
    case EDITBOX_STANDARD:
      setIntern("Type", "text");
      break;
    case EDITBOX_PASSWORD:
      setIntern("Type", "password");
      break;
    }

    setIntern("Name", getName());
    setIntern("Value", getValue());
    if (sCaption != "") {
      setIntern("Caption", sCaption);
      setIntern("Caption", outputTemplate("caption"));
    }
    if (iMaxLength != -1) sParams += " maxlength=\"" + intstr(iMaxLength) + "\"";
    if (iSize != -1) sParams += " size=\"" + intstr(iSize) + "\" ";
    if (!(getState() & STATE_ENABLED)) sParams += " disabled=\"disabled\"";
    if (!(getState() & STATE_READWRITE)) sParams += " readonly=\"readonly\"";
    setIntern("Optional", sParams);

    output += outputTemplate();
  }
  return output;
}
