/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: aplexecutor.cpp,v 1.16 2002/03/29 22:51:26 ach Exp $ */


#include "aplexecutor.h"

using namespace std;

static CAPLExecutorStatic sGlobal;

void CAPLExecutor::setVar(const string &sKey, const string &sValue) {
  Var[sKey] = sValue;
}

void CAPLExecutor::setSlot(const string &key, const string &value) {
  Slot[key] = value;
}

void CAPLExecutor::setGlobal(const string &sKey, const string &sValue) {
  sGlobal.setGlobal(sKey, sValue);
}

void CAPLExecutor::setIntern(const string &sKey, const string &sValue) {
  Intern[sKey] = sValue;
}

void CAPLExecutor::setStyleVar(const string &key, const string &value) {
  sGlobal.setStyleVar(key, value);
}

void CAPLExecutor::setChildren(const string &value) {
  childrenData = value;
}

void CAPLExecutor::addChildren(const string &value) {
  childrenData += value;
}

const string &CAPLExecutor::getVar(const string &sKey) {
  return Var[sKey];
}

const string &CAPLExecutor::getSlot(const string &key) {
  return Slot[key];
}

const string &CAPLExecutor::getGlobal(const string &sKey) {
  return sGlobal.getGlobal(sKey);
}

const string &CAPLExecutor::getIntern(const string &sKey) {
  return Intern[sKey];
}

const string &CAPLExecutor::getStyleVar(const string &key) {
  return sGlobal.getStyleVar(key);
}

const string &CAPLExecutor::getStyleDir() {
  return sStyleDir;
}

const string &CAPLExecutor::getThemeDir() {
  return sThemeDir;
}

const string &CAPLExecutor::getChildren() {
  return childrenData;
}

void CAPLExecutor::clearGlobal() {
  sGlobal.clearGlobal();
  sGlobal.clearStyle();
}


const string &CAPLExecutorStatic::getGlobal(const string &sKey) {
  return Global[sKey];
}

const string &CAPLExecutorStatic::getStyleVar(const string &sKey) {
  return Style[sKey];
}

void CAPLExecutorStatic::setGlobal(const string &sKey, const string &sValue) {
  Global[sKey] = sValue;
}

void CAPLExecutorStatic::clearGlobal() {
  Global.clear();
}

void CAPLExecutorStatic::setStyleVar(const string &sKey, const string &sValue) {
  Style[sKey] = sValue;
}

void CAPLExecutorStatic::clearStyle() {
  Style.clear();
}
