/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: aplgroupbox.cpp,v 1.18 2002/09/24 15:04:21 k Exp $ */


#include "aplgroupbox.h"

using namespace std;

CAPLGroupBox::CAPLGroupBox(CAPLObject* Parent) : CAPLObject(Parent) {
  sCaption = "";
  sWidth = "200";
  sHeight = "100";
  setTemplate("groupbox");
}

void CAPLGroupBox::setCaption(const string &sNewCaption) {
  sCaption = sNewCaption;
}

void CAPLGroupBox::setWidth(const string &sNewWidth) {
  sWidth = sNewWidth;
}

void CAPLGroupBox::setHeight(const string &sNewHeight) {
  sHeight = sNewHeight;
}

string CAPLGroupBox::output() {
  string output = "";
  if (getState() & STATE_VISIBLE) {
    setIntern("Width", sWidth);
    setIntern("Height", sHeight);
    setIntern("Caption", sCaption);

    prepare();
    output += outputTemplate();
  }
  return output;
}
