/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: aplhiddenfield.cpp,v 1.21 2002/09/24 15:04:22 k Exp $ */


#include "aplhiddenfield.h"

using namespace std;

CAPLHiddenField::CAPLHiddenField(CAPLObject* Parent) : CAPLFormObject(Parent) {
  setTemplate("hiddenfield");
}

string CAPLHiddenField::output() {
  string output = "";
  if (getState() & STATE_VISIBLE) {
    string params = "";
    prepare();
    setIntern("Name", getName());
    setIntern("Value", getValue());

    if (!(getState() & STATE_ENABLED)) params += " disabled=\"disabled\"";
    if (!(getState() & STATE_READWRITE)) params += " readonly=\"readonly\"";
    setIntern("Optional", params);
    output += outputTemplate();
  }
  return output;
}
