/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: aplhyperlink.cpp,v 1.23 2002/09/24 15:04:22 k Exp $ */


#include "aplhyperlink.h"

using namespace std;

CAPLHyperLink::CAPLHyperLink(CAPLObject* Parent) : CAPLObject(Parent) {
  sLink = "";
  sText = "";
  sTarget = "";
  setTemplate("hyperlink");
}

void CAPLHyperLink::setText(const string &sNewText) {
  sText = sNewText;
}

void CAPLHyperLink::setTarget(const string &sNewTarget) {
  sTarget = sNewTarget;
}

void CAPLHyperLink::setLink(const string &sNewLink) {
  sLink = sNewLink;
}

string CAPLHyperLink::output() {
  string output = "";
  if (getState() & STATE_VISIBLE) {
    string sParams = "";

    prepare();

    if (sTarget.length()) sParams += "target=\"" + sTarget + "\" ";
    if (sLink.length() || ActionHandler) {
      string sHREF;
      if (sLink.length())
        sHREF = getQueryString(sLink);
      else
        sHREF = getQueryString(ActionHandler->getPage());  
      sParams += "href=\"" + sHREF + "\" ";
    }
    setIntern("Text", sText);
    setIntern("Optional", sParams);

    output += outputTemplate();
  }
  return output;
}
