/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: aplimage.cpp,v 1.27 2002/09/24 15:04:22 k Exp $ */


#include "aplimage.h"

using namespace strutilsxx;
using namespace std;

CAPLImage::CAPLImage(CAPLObject* Parent) : CAPLObject(Parent) {
  sSource = "";
  sWidth = "";
  sHeight = "";
  sAlt = "";
  iBorder = -1;
  iHSpace = -1;
  iVSpace = -1;
  sAlign = "";
  setTemplate("image");
}

void CAPLImage::setSource(const string &sNewSource) {
  sSource = sNewSource;
}

void CAPLImage::setWidth(const string &sNewWidth) {
  sWidth = sNewWidth;
}

void CAPLImage::setHeight(const string &sNewHeight) {
  sHeight = sNewHeight;
}

void CAPLImage::setAlt(const string &sNewAlt) {
  sAlt = sNewAlt;
}

void CAPLImage::setBorder(const int &iNewBorder) {
  iBorder = iNewBorder;
}

void CAPLImage::setHSpace(const int &iNewHSpace) {
  iHSpace = iNewHSpace;
}

void CAPLImage::setVSpace(const int &iNewVSpace) {
  iVSpace = iNewVSpace;
}

void CAPLImage::setAlign(const string &sNewAlign) {
  sAlign = sNewAlign;
}

void CAPLImage::setMap(const string &sNewMap) {
  sMap = sNewMap;
}

string CAPLImage::output() {
  string output = "";
  if (getState() & STATE_VISIBLE) {
    string sParams = "";
    string sImageSource = sSource;

    if (getValue() != "") sImageSource = sSource + getValue();
    setIntern("Source", sImageSource);
    if (sWidth != "") sParams += "width=\"" + sWidth + "\" ";
    if (sHeight != "") sParams += "height=\"" + sHeight + "\" ";
    if (iHSpace != -1) sParams += "hspace=\"" + intstr(iHSpace) + "\" ";
    if (iVSpace != -1) sParams += "vspace=\"" + intstr(iVSpace) + "\" ";
    sParams += "alt=\"" + sAlt + "\" ";
    if (sAlign != "") sParams += "align=\"" + sAlign + "\" ";
    if (iBorder != -1) sParams += "border=\"" + intstr(iBorder) + "\" ";
    if (sMap.length()) sParams += "usemap=\"#" + sMap + "\" ";
    setIntern("Optional", sParams);
    prepare();
    output += outputTemplate();
  }
  return output;
}

