/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: apllistobject.cpp,v 1.19 2002/09/24 15:04:22 k Exp $ */


#include "apllistobject.h"

using namespace strutilsxx;
using namespace std;

CAPLListObject::CAPLListObject(CAPLObject* Parent) : CAPLObject(Parent) {
  bCompact = false;
  sType = "";
}

void CAPLListObject::setType(const string &sNewType) {
  sType = sNewType;
}

void CAPLListObject::setCompact(const bool &bNewCompact) {
  bCompact = bNewCompact;
}

CAPLOrderedList::CAPLOrderedList(CAPLObject* Parent) : CAPLListObject(Parent) {
  iStart = -1;
  setTemplate("orderedlist");
}

void CAPLOrderedList::setStart(const int &sNewStart) {
  iStart = sNewStart;
}

string CAPLOrderedList::output() {
  string output = "";
  if (getState() & STATE_VISIBLE) {
    string sParams = "";

    if (sType != "") sParams += "type=\"" + sType + "\" ";
    if (iStart != -1) sParams += "start=\"" + intstr(iStart) + "\" ";
    if (bCompact) sParams = sParams + " compact";
    setIntern("Optional", sParams);

    for (int i = 0; i < getChildrenCount(); i++) {
      setChildren(getChild(i)->output());
      output += outputTemplate("item");
    }

    setChildren(output);
    output = outputTemplate();
  }
  return output;
}


CAPLBulletList::CAPLBulletList(CAPLObject* Parent) : CAPLListObject(Parent) {
  setTemplate("bulletlist");
}

string CAPLBulletList::output() {
  string output = "";
  if (getState() & STATE_VISIBLE) {
    string sParams = "";

    if (sType != "") sParams += "type=\"" + sType + "\" ";
    if (bCompact) sParams = sParams + " compact";
    setIntern("Optional", sParams);

    for (int i = 0; i < getChildrenCount(); i++) {
      setChildren(getChild(i)->output());
      output += outputTemplate("item");
    }

    setChildren(output);
    output = outputTemplate();
  }
  return output;
}
