/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: aplops.cpp,v 1.21 2002/03/17 13:23:47 ach Exp $ */


#include "aplops.h"
#include "aploplist.h"
#include "php_apl_public.h"

using namespace std;

CAPLOpOneArg::CAPLOpOneArg(const char *data, size_t len) {
  this->data.assign(data, len);
}

string CAPLOpVar::execute(CAPLExecutor *executor) {
  return executor->getVar(data);
}

string CAPLOpSlot::execute(CAPLExecutor *executor) {
  return executor->getSlot(data);
}

string CAPLOpGlobal::execute(CAPLExecutor *executor) {
  return executor->getGlobal(data);
}

string CAPLOpIntern::execute(CAPLExecutor *executor) {
  return executor->getIntern(data);
}

string CAPLOpString::execute(CAPLExecutor *executor) {
  return data;
}

void CAPLOpString::append(const char *text, size_t len) {
  data.append(text, len);
}

string CAPLOpChildren::execute(CAPLExecutor *executor) {
  return executor->getChildren();
}

string CAPLOpTheme::execute(CAPLExecutor *executor) {
  return APLG(sTheme);
}

string CAPLOpStyle::execute(CAPLExecutor *executor) {
  return executor->getStyleVar(data);
}

string CAPLOpThemeDir::execute(CAPLExecutor *executor) {
  return executor->getThemeDir();
}

string CAPLOpStyleDir::execute(CAPLExecutor *executor) {
  return executor->getStyleDir();
}

string CAPLOpNewline::execute(CAPLExecutor *executor) {
  return "\n";
}
