/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: aplupload.cpp,v 1.19 2002/09/24 15:04:22 k Exp $ */


#include "aplupload.h"

using namespace strutilsxx;
using namespace std;

CAPLUpload::CAPLUpload(CAPLObject* Parent) : CAPLFormObject(Parent) {
  iSize = -1;
  setCollector(&CAPLUpload::makeFilename, NULL, NULL);
  setTemplate("upload");
}

int CAPLUpload::makeFilename(void *dummy, void *collectData) {

  apl_formobject_collector *data = (apl_formobject_collector *) collectData;
  data->actionData->value = data->actionData->data["name"].value;

  return 0;
}

void CAPLUpload::setSize(const int &size) {
  this->iSize = size;
}

void CAPLUpload::setAccept(const string &accept) {
  this->accept = accept;
}

string CAPLUpload::output() {
  string output = "";
  if (getState() & STATE_VISIBLE) {
    string sParams = "";

    prepare();
    setIntern("Name", getName());
    setIntern("Value", getValue());
    if (sCaption != "") {
      setIntern("Caption", sCaption);
      setIntern("Caption", outputTemplate("caption"));
    }
    if (iSize != -1) sParams += " size=\"" + intstr(iSize) + "\"";
    if (accept != "") sParams += " accept=\"" + accept + "\"";
    if (!(getState() & STATE_READWRITE)) sParams += " readonly=\"readonly\"";
    if (!(getState() & STATE_ENABLED)) sParams += " disabled=\"disabled\"";
    setIntern("Optional", sParams);

    output += outputTemplate();
  }
  return output;
}
