/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: php_apl_apl.cpp,v 1.22 2002/03/17 13:23:47 ach Exp $ */



#include "apl.h"
#include "php_apl.h"
#include "php_apl_calls.h"

extern "C" {
# include "main/php.h"
# include "main/php_ini.h"
}

using namespace std;

ZEND_FUNCTION(CAPL_CAPL) {
  CAPL * _result;

  CATCH_ERROR_BEGIN()
  _result = (CAPL *) new CAPL();
  zend_list_insert(_result, le_CAPL);
  add_property_resource(this_ptr, "this", (long) _result);
  CATCH_ERROR_END()
}

ZEND_FUNCTION(CAPL_setTemplateDir) {
  zval **args[2];
  int arg_count = ZEND_NUM_ARGS();
  string sTemplateAlias = "";
  string sTemplateDir = "";

  if (arg_count > 2 || arg_count < 1 || zend_get_parameters_array_ex(arg_count, args))
    WRONG_PARAM_COUNT;

  switch (arg_count) {
    case 2:
      convert_to_string_ex(args[1]);
      sTemplateAlias = Z_STRVAL_PP(args[1]);
      php_alter_ini_entry("apl.template_alias", sizeof("apl.template_alias"), (char *) sTemplateAlias.c_str(), sTemplateAlias.length(), PHP_INI_USER, PHP_INI_STAGE_RUNTIME);
    case 1:
      convert_to_string_ex(args[0]);
      if (Z_STRVAL_PP(args[0])[0] != '/') {
        aplPrependDocumentRoot(Z_STRVAL_PP(args[0]), Z_STRLEN_PP(args[0]), &sTemplateDir);
      } else {
        sTemplateDir.assign(Z_STRVAL_PP(args[0]), Z_STRLEN_PP(args[0]));
      }
      php_alter_ini_entry("apl.template_dir", sizeof("apl.template_dir"), (char *) sTemplateDir.c_str(), sTemplateDir.length(), PHP_INI_USER, PHP_INI_STAGE_RUNTIME);
  }
}

ZEND_FUNCTION(CAPL_setTemplateAlias) {
  zval **newTemplateAlias;

  if (zend_get_parameters_ex(1, &newTemplateAlias)) WRONG_PARAM_COUNT;
  convert_to_string_ex(newTemplateAlias);
  php_alter_ini_entry("apl.template_alias", sizeof("apl.template_alias"), Z_STRVAL_PP(newTemplateAlias), Z_STRLEN_PP(newTemplateAlias), PHP_INI_USER, PHP_INI_STAGE_RUNTIME);
}

ZEND_FUNCTION(CAPL_setTemplateType) {
  zval **newTemplateType;

  if (zend_get_parameters_ex(1, &newTemplateType)) WRONG_PARAM_COUNT;
  convert_to_string_ex(newTemplateType);
  php_alter_ini_entry("apl.template_type", sizeof("apl.template_type"), Z_STRVAL_PP(newTemplateType), Z_STRLEN_PP(newTemplateType), PHP_INI_USER, PHP_INI_STAGE_RUNTIME);
}

ZEND_FUNCTION(CAPL_setStyleFile) {
  zval **newString;

  if (zend_get_parameters_ex(1, &newString)) WRONG_PARAM_COUNT;
  convert_to_string_ex(newString);
  php_alter_ini_entry("apl.style_file", sizeof("apl.style_file"),
                      Z_STRVAL_PP(newString), Z_STRLEN_PP(newString), PHP_INI_USER,
                      PHP_INI_STAGE_RUNTIME);
}

ZEND_FUNCTION(CAPL_setTheme) {
  zval **newTheme;

  if (zend_get_parameters_ex(1, &newTheme)) WRONG_PARAM_COUNT;
  convert_to_string_ex(newTheme);
  php_alter_ini_entry("apl.theme", sizeof("apl.theme"), Z_STRVAL_PP(newTheme), Z_STRLEN_PP(newTheme), PHP_INI_USER, PHP_INI_STAGE_RUNTIME);
}

ZEND_FUNCTION(CAPL_setClassChecks) {
  zval **arg;
  string arg0 = "true";

  if (ZEND_NUM_ARGS() > 0) {
    if (zend_get_parameters_ex(1, &arg)) WRONG_PARAM_COUNT;
    convert_to_string_ex(arg);
    arg0 = Z_STRVAL_PP(arg);
  }
  php_alter_ini_entry("apl.class_checks", sizeof("apl.class_checks"), (char *) arg0.c_str(), arg0.length(), PHP_INI_USER, PHP_INI_STAGE_RUNTIME);
}

ZEND_FUNCTION(CAPL_setStyle) {
  zval **newStyle;

  if (zend_get_parameters_ex(1, &newStyle)) WRONG_PARAM_COUNT;
  convert_to_string_ex(newStyle);
  php_alter_ini_entry("apl.style", sizeof("apl.style"), Z_STRVAL_PP(newStyle), Z_STRLEN_PP(newStyle), PHP_INI_USER, PHP_INI_STAGE_RUNTIME);
}
