/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: php_apl_combobox.cpp,v 1.23 2001/11/21 13:18:16 ach Exp $ */


#include "aplcombobox.h"
#include "php_apl.h"

using namespace std;

ZEND_FUNCTION(CAPLComboBox_addItem) {
  zval **args[3];
  int arg_count = ZEND_NUM_ARGS();

  if (arg_count > 3 || arg_count < 1 || zend_get_parameters_array_ex(arg_count, args))
    WRONG_PARAM_COUNT;

  switch (arg_count) {
  case 3:
    convert_to_string_ex(args[2]);
  case 2:
    convert_to_string_ex(args[1]);
    break;
  }
  convert_to_string_ex(args[0]);

  CATCH_ERROR_BEGIN()
  zend_class_entry *ce;
  zval *array;
  zval *obj;
  zval **arrayp;

  if (zend_hash_find(Z_OBJPROP_P(this_ptr), "Item", sizeof("Item"), (void **) &arrayp) != SUCCESS) {
    MAKE_STD_ZVAL(array);
    array_init(array);
    zend_hash_update(Z_OBJPROP_P(this_ptr), "Item", sizeof("Item"), (void *) &array, sizeof(zval *), NULL);
  } else {
    array = *arrayp;
  }

  ce = aplGetClassEntry("caplcomboboxitem");
  MAKE_STD_ZVAL(obj);
  object_init_ex(obj, ce);
  zend_hash_next_index_insert(Z_ARRVAL_P(array), (void *) &obj, sizeof(zval *), NULL);
  aplCallMethod(&obj, "caplcomboboxitem", 1, this_ptr);
  aplCallMethod(&obj, "setvalue", 1, *args[0]);
  switch (arg_count) {
  case 3:
    aplCallMethod(&obj, "setselected", 1, *args[2]);
  case 2:
    aplCallMethod(&obj, "settext", 1, *args[1]);
  }
  CATCH_ERROR_END()
}
