/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: php_apl_database.cpp,v 1.23 2001/11/21 13:18:16 ach Exp $ */


#include "apldatabase.h"
#include "php_apl.h"

using namespace std;

ZEND_FUNCTION(CAPLDatabase_openQuery) {
  zval **args[2];
  string _arg1;
  int arg_count = ZEND_NUM_ARGS();

  if (arg_count < 1 || arg_count > 2 || zend_get_parameters_array_ex(arg_count, args))
    WRONG_PARAM_COUNT;

  convert_to_string_ex(args[0]);

  CATCH_ERROR_BEGIN()
  zend_class_entry *ce;

  ce = aplGetClassEntry("capldbresult");
  object_init_ex(return_value, ce);
  if (arg_count == 2) {
    convert_to_long_ex(args[1]);
    aplCallMethod(&return_value, "capldbresult", 2, this_ptr, *args[1]);
  } else
    aplCallMethod(&return_value, "capldbresult", 1, this_ptr);
  aplCallMethod(&return_value, "query", 1, *args[0]);
  CATCH_ERROR_END()
}

ZEND_FUNCTION(CAPLDBResult_CAPLDBResult) {
  CAPLDBResult *_result = NULL;
  CAPLDatabase *Parent;
  zval **args[2];
  int arg_count = ZEND_NUM_ARGS();

  if (arg_count > 2 || arg_count < 1 || zend_get_parameters_array_ex(arg_count, args))
    WRONG_PARAM_COUNT;

  Parent = (CAPLDatabase *) aplGetClassEx(*args[0], "this", "first", 1, "CAPLDatabase");

  CATCH_ERROR_BEGIN()
  if (arg_count == 2) {
    convert_to_long_ex(args[1]);
    _result = (CAPLDBResult *) new CAPLDBResult(Parent, Z_LVAL_PP(args[1]));
  } else
    _result = (CAPLDBResult *) new CAPLDBResult(Parent);
  CATCH_ERROR_END()

  if (_result) {
    zend_list_insert(_result, le_CAPLDBResult);
    add_property_resource(this_ptr, "this", (long) _result);
  }
}
