/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: php_apl_datacontrolobject.cpp,v 1.31 2001/11/21 13:18:16 ach Exp $ */


#include "apldatacontrolobject.h"
#include "apldbcontrol.h"
#include "php_apl.h"
#include "php_apl_calls.h"

extern "C" {
# include "php.h"
}

using namespace std;

static int aplCallbackEvent(void *dummy, void *dummy2) {
  apl_php_callback_t *php_dat = (apl_php_callback_t *) dummy;
  apl_datacontrol_event *apl_dat = (apl_datacontrol_event *) dummy2;

  return aplCallHandlerEvent(php_dat->func, apl_dat->Key, apl_dat->Hash);
}

ZEND_FUNCTION(CAPLDBControl_setCallback) {
  CAPLDBControl *Class;
  zval **arg[2];
  apl_php_callback_t *dat;

  if (zend_get_parameters_ex(2, &arg[0], &arg[1])) WRONG_PARAM_COUNT;
  convert_to_long_ex(arg[0]);
  if (Z_LVAL_PP(arg[0]) >= EVENT_NUMBER || Z_LVAL_PP(arg[0]) < 0) {
    php_error(E_WARNING, "Event number exceeds limit");
    return ;
  }
  ZVAL_ADDREF(*arg[1]);
  dat = (apl_php_callback_t *) emalloc(sizeof(*dat));
  dat->func = *arg[1];
  CATCH_ERROR_BEGIN()
  Class = (CAPLDBControl *) aplGetClass(this_ptr);
  Class->setCallback(Z_LVAL_PP(arg[0]), aplCallbackEvent, aplCallbackDestructor, dat);
  CATCH_ERROR_END()
}
