/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: php_apl_datagrid.cpp,v 1.42 2001/11/21 13:18:16 ach Exp $ */


#include "apldatagrid.h"
#include "php_apl.h"
#include "php_apl_calls.h"

extern "C" {
# include "php.h"
}

using namespace std;

ZEND_FUNCTION(CAPLDataGrid_createFields) {
  zval **arg[1];

  if (zend_get_parameters_ex(1, &arg[0])) WRONG_PARAM_COUNT;
  convert_to_array_ex(arg[0]);
  CATCH_ERROR_BEGIN()
  int iStatus;
  ulong iIndex;
  char *sIndex = NULL;
  zval **Data;
  zend_class_entry *ce;
  zval *array;

  MAKE_STD_ZVAL(array);
  array_init(array);

  ce = aplGetClassEntry("capldatagridfield");
  while ((iStatus = zend_hash_get_current_key_old(Z_ARRVAL_PP(arg[0]), &sIndex, &iIndex)) != HASH_KEY_NON_EXISTANT) {
    zval * obj;

    if (sIndex) {
      efree(sIndex);
      sIndex = NULL;
    }
    MAKE_STD_ZVAL(obj);
    object_init_ex(obj, ce);
    zend_hash_get_current_data(Z_ARRVAL_PP(arg[0]), (void **) &Data);
    convert_to_string_ex(Data);
    zend_hash_update(Z_ARRVAL_P(array), Z_STRVAL_PP(Data), Z_STRLEN_PP(Data) + 1, (void *)&obj, sizeof(zval *), NULL);
    zend_hash_move_forward(Z_ARRVAL_PP(arg[0]));
    aplCallMethod(&obj, "capldatagridfield", 1, this_ptr);
    aplCallMethod(&obj, "setname", 1, *Data);
    aplCallMethod(&obj, "setcaption", 1, *Data);
  }
  zend_hash_update(Z_OBJPROP_P(this_ptr), "Field", sizeof("Field"), (void *) &array, sizeof(zval *), NULL);
  CATCH_ERROR_END()
}
