/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: php_apl_funcs.cpp,v 1.13 2001/12/07 13:10:52 ach Exp $ */


#include "php_apl.h"
#include "apllistobject.h"
#include "apldataset.h"
#include "aplengine.h"
#include "php_apl_calls.h"

using namespace std;

ZEND_NAMED_FUNCTION(aplCreateLookup) {
  zval **arg[2];
  string _arg1;

  if (zend_get_parameters_ex(2, &arg[0], &arg[1]))
    WRONG_PARAM_COUNT;
  convert_to_string_ex(arg[1]);

  CATCH_ERROR_BEGIN()
  zend_class_entry *ce;
  zval *object;

  MAKE_STD_ZVAL(object);
  ce = aplGetClassEntry("capldatalookup");
  object_init_ex(object, ce);
  aplCallMethod(&object, "capldatalookup", 1, this_ptr);
  aplCallMethod(&object, "setname", 1, *arg[1]);
  aplCallMethod(&object, "setdatacontrol", 1, *arg[0]);
  zend_hash_update(Z_OBJPROP_P(this_ptr), "Lookup", sizeof("Lookup"), (void *) &object, sizeof(zval *), NULL);
  CATCH_ERROR_END()
}

ZEND_NAMED_FUNCTION(aplSetTemplateDir) {
  CAPLEngine *Class;
  zval **args[2];
  int arg_count = ZEND_NUM_ARGS();
  string sTemplateAlias = "";
  string sTemplateDir = "";

  if (zend_get_parameters_array_ex(2, args)) WRONG_PARAM_COUNT;

  switch (arg_count) {
    case 2:
      convert_to_string_ex(args[1]);
      sTemplateAlias = Z_STRVAL_PP(args[1]);
    case 1:
      convert_to_string_ex(args[0]);
      if (Z_STRVAL_PP(args[0])[0] != '/') {
        aplPrependDocumentRoot(Z_STRVAL_PP(args[0]), Z_STRLEN_PP(args[0]), &sTemplateDir);
      } else {
        sTemplateDir.assign(Z_STRVAL_PP(args[0]), Z_STRLEN_PP(args[0]));
      }
  }

  CATCH_ERROR_BEGIN()
  Class = (CAPLEngine *) aplGetClass(this_ptr);
  switch (arg_count) {
    case 1:
      Class->setTemplateDir(sTemplateDir);
      break;
    case 2:
      Class->setTemplateDir(sTemplateDir, sTemplateAlias);
      break;
  }
  CATCH_ERROR_END()
}


#include "php_apl_funcs_body.cpp"
