/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: php_apl_table.cpp,v 1.25 2001/11/21 13:18:16 ach Exp $ */


#include "apltable.h"
#include "php_apl.h"
#include "php_apl_calls.h"

using namespace std;

ZEND_FUNCTION(CAPLTable_createMatrix) {
  zval **args[2];
  long iRows, iCols;
  CAPLTable *Class;
  string templateType;
  zval *templateTypeArg[1];

  if (zend_get_parameters_ex(2, &args[0], &args[1])) WRONG_PARAM_COUNT;
  convert_to_long_ex(args[1]);
  iRows = Z_LVAL_PP(args[1]);
  convert_to_long_ex(args[0]);
  iCols = Z_LVAL_PP(args[0]);

  zend_class_entry *ce;
  zval *array;
  MAKE_STD_ZVAL(array);
  array_init(array);

  CATCH_ERROR_BEGIN()
  Class = (CAPLTable *) aplGetClass(this_ptr);
  templateType = Class->getTemplateType();
  CATCH_ERROR_END()

  aplCreateArguments(1, templateTypeArg);
  ZVAL_STRINGL(templateTypeArg[0], (char *) templateType.c_str(), templateType.length(), 1);

  ce = aplGetClassEntry("capltablerow");
  for (int i = 0; i < iRows; i++) {
    zval *obj;
    MAKE_STD_ZVAL(obj);
    object_init_ex(obj, ce);
    zend_hash_index_update(Z_ARRVAL_P(array), i, (void *) &obj, sizeof(zval *), NULL);
    aplCallMethod(&obj, "capltablerow", 1, this_ptr);
    aplCallMethod(&obj, "settemplatetype", 1, templateTypeArg[0]);
    aplCallMethod(&obj, "createcells", 1, *args[0]);
  }
  aplDestroyArguments(1, templateTypeArg);
  zend_hash_update(Z_OBJPROP_P(this_ptr), "Row", sizeof("Row"), (void *) &array, sizeof(zval *), NULL);
}
