/*************************************************************************
* apl - abstract presentation layer                                      *
* ---------------------------------------------------------------------- *
* Copyright (C) 2000 - 2001 twisd AG, <http://www.twisd.de>              *
* See AUTHORS file for a list of contributing developers                 *
*                                                                        *
* This library is free software; you can redistribute it and/or          *
* modify it under the terms of the GNU Lesser General Public             *
* License as published by the Free Software Foundation; either           *
* version 2 of the License, or (at your option) any later version.       *
*                                                                        *
* This library is distributed in the hope that it will be useful,        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of         *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
* Library General Public License for more details.                       *
*                                                                        *
* You should have received a copy of the GNU Lesser General Public       *
* License along with this progam; if not, write to the                   *
* Free Software Foundation, Inc., 59 Temple Place - Suite 330,           *
* Boston, MA 02111-1307, USA.                                            *
*************************************************************************/

/* $Id: php_apl_tablerow.cpp,v 1.25 2001/11/21 13:18:16 ach Exp $ */


#include "apltable.h"
#include "php_apl.h"
#include "php_apl_calls.h"

using namespace std;

ZEND_FUNCTION(CAPLTableRow_createCells) {
  zval **args[1];
  long iCols;
  string templateType;
  zval *templateTypeArg[1];
  CAPLTableRow *Class;


  if (zend_get_parameters_ex(1, &args[0])) WRONG_PARAM_COUNT;
  convert_to_long_ex(args[0]);
  iCols = (*args[0])->value.lval;
  zend_class_entry *ce;

  CATCH_ERROR_BEGIN()
  Class = (CAPLTableRow *) aplGetClass(this_ptr);
  templateType = Class->getTemplateType();
  CATCH_ERROR_END()

  ce = aplGetClassEntry("capltablecell");
  zval *array;
  MAKE_STD_ZVAL(array);
  array_init(array);

  aplCreateArguments(1, templateTypeArg);
  ZVAL_STRINGL(templateTypeArg[0], (char *) templateType.c_str(), templateType.length(), 1);

  for (int i = 0; i < iCols; i++) {
    zval *obj;
    MAKE_STD_ZVAL(obj);
    zend_hash_index_update(Z_ARRVAL_P(array), i, (void *) &obj, sizeof(zval *), NULL);
    object_init_ex(obj, ce);
    aplCallMethod(&obj, "capltablecell", 1, this_ptr);
    aplCallMethod(&obj, "settemplatetype", 1, templateTypeArg[0]);
  }
  aplDestroyArguments(1, templateTypeArg);
  zend_hash_update(Z_OBJPROP_P(this_ptr), "Cell", sizeof("Cell"), (void *) &array, sizeof(zval *), NULL);
}
