# $Id: create_funcs.awk,v 1.21 2002/09/24 15:04:22 k Exp $

function getval(type, argc) 
{
  if (type == "string") return "Z_STRVAL_PP(arg[" argc "])"
  if (type == "boolean") return "Z_BVAL_PP(arg[" argc "])"
  if (type == "long") return "Z_LVAL_PP(arg[" argc "])"
  if (type == "double") return "Z_DVAL_PP(argx[" argx "])"
  if (type == "stringarray") return "convertToStringVector(Z_ARRVAL_PP(arg[" argc "]))"
  if (type == "booleanarray") return "convertToBoolVector(Z_ARRVAL_PP(arg[" argc "]))"
  if (type == "longarray") return "convertToLongVector(Z_ARRVAL_PP(arg[" argc "]))"
  if (type == "doublearray") return "convertToDoubleVector(Z_ARRVAL_PP(arg[" argc "]))"
  if (type in baseclass) {
    return "(" baseclass[type] " *) aplGetClassEx(*arg[" argc "], \"this\", \"" (argc+1) ".\", " allowed_class[type] ")";
  }
}

function convert_to(type, argc) 
{
  if (type in baseclass) {
    return ";"
  }
  if (type ~ /.*array$/) {
    return "convert_to_array_ex(arg[" argc "]);"
  }
  return "convert_to_" type "_ex(arg[" argc "]);"
}

function assign_to(type)
{
  if (type == "void") return " "
  return "result = "
}

function result_type(type)
{
  if (type == "void") return ""
  if (type == "boolean") return "bool result = false"
  if (type == "double") return "float result = 0"
  if (type in baseclass) return type " *result = NULL"
    
  return type " result = 0"
}

function retval(type)
{
  if (type == "void") return ""
  if (type == "boolean") return "RETVAL_BOOL(result)"
  if (type == "string") return "RETVAL_STRINGL((char *) result.c_str(), result.length(), 1)"
  if (type == "long") return "RETVAL_LONG(result)"
  if (type == "double") return "RETVAL_DOUBLE(result)"
}

function ctor_one_opt(funcname, type)
{
  print "ZEND_FUNCTION(" classname "_" funcname ") {"
  print "  " classname " *_result;"
  print "  " baseclass[type] " *Parent = NULL;"
  print "  zval **arg;"
  print "  if (ZEND_NUM_ARGS()) {"
  print "    if (zend_get_parameters_ex(1, &arg)==FAILURE) WRONG_PARAM_COUNT;"
  print "    if ((*arg)->type != IS_NULL)"
  print "      Parent = (" baseclass[type] " *) aplGetClassEx(*arg, \"this\", \"first\", " allowed_class[type] ");"
  print "  }"
  print "  if (Parent == NULL)"
  print "    _result = (" classname " *) new " classname "();"
  print "  else"
  print "    _result = (" classname " *) new " classname "(Parent);"
  print "  zend_list_insert(_result, le_" classname ");"
  print "  add_property_resource(this_ptr, \"this\", (long) _result);"
  print "}"
}

function ctor_one(funcname, type)
{
  print "ZEND_FUNCTION(" classname "_" funcname ") {"
  print "  " classname " *_result;"
  print "  " baseclass[type] " *Parent;"
  print "  zval **arg;"
  print "  if (zend_get_parameters_ex(1, &arg)==FAILURE) WRONG_PARAM_COUNT;"
  print "  Parent = (" baseclass[type] " *) aplGetClassEx(*arg, \"this\", \"first\", " allowed_class[type] ");"
  print "  _result = (" classname " *) new " classname "(Parent);"
  print "  zend_list_insert(_result, le_" classname ");"
  print "  add_property_resource(this_ptr, \"this\", (long) _result);"
  print "}"
}

function ctor_void(funcname)
{
  print "ZEND_FUNCTION(" classname "_" funcname ") {"
  print "  " classname " *_result;"
  print "  _result = (" classname " *) new " classname "();"
  print "  zend_list_insert(_result, le_" classname ");"
  print "  add_property_resource(this_ptr, \"this\", (long) _result);"
  print "}"
}

function print_function_body(rettype, funcname, args, argsize) 
{
  if (args[0] != "") {
    if (wrote_include == 0) {
      include=substr(tolower(classname) ".h", 2)
      if (system("test -r " srcdir "/../include/" include) == 0)
        print "#include \"" include "\""
      wrote_include=1
    }
    
    if (args[0] == "alias") {
      print "ZEND_FUNCTION(" classname "_" funcname ") {"
      print "  " args[1] "(INTERNAL_FUNCTION_PARAM_PASSTHRU);"
      print "}"
      return
    }

    if (args[0] == "ctor_one_opt") {
      ctor_one_opt(funcname, args[1])
      return
    }

    if (args[0] == "ctor_one") {
      ctor_one(funcname, args[1])
      return
    }

    if (args[0] == "ctor_void") {
      ctor_void(funcname)
      return
    }
    argc=0
    opt_start=-1
    conv_list=""
    param_list=""
    for (j in args) {
      i=args[j]
      if (i == "void") break
      if (pos = index(i, "=")) {
        if (opt_start == -1)
          opt_start=argc

        type=substr(i, 1, pos - 1)
        def=substr(i, pos + 1)
        
        conv_list=conv_list "  if (ZEND_NUM_ARGS()>" argc ") " convert_to(type, argc) "\n"
        param_list=param_list "ZEND_NUM_ARGS()>" argc "?" getval(type, argc) ":" def
      } else {
        conv_list=conv_list "  " convert_to(i, argc) "\n"
        param_list=param_list getval(i, argc)
      }
      if (j < argsize) param_list=param_list ", "
      argc++
    }
    
    if (opt_start != -1) {
      fetch_list="if (ZEND_NUM_ARGS() < " opt_start "\n        || ZEND_NUM_ARGS() > " argc "\n        || zend_get_parameters_array_ex(ZEND_NUM_ARGS(),arg)==FAILURE) WRONG_PARAM_COUNT;" 
    } else if (argc > 0) {
      fetch_list="if (zend_get_parameters_array_ex(" argc ", arg) == FAILURE) WRONG_PARAM_COUNT;"
    } else
      fetch_list=""
    
    print "ZEND_FUNCTION(" classname "_" funcname ") {"
    print "  " classname " *Class;"
    print "  " result_type(rettype) ";"
    if (argc) {
      print "  zval **arg[" argc "];"
      print "  " fetch_list
      print conv_list
    }
    print "  CATCH_ERROR_BEGIN()"
    print "    Class = (" classname " *) aplGetClass(this_ptr);"
    print "  " assign_to(rettype) " Class->" funcname "(" param_list ");"
    print "  CATCH_ERROR_END()"
    print "  " retval(rettype) ";"
    print "}"
  }
}

BEGIN {
  print "// This file has been automatically created from php_if_table.txt"
  print "//                       *** WARNING ***"
  print "// Do NOT change this file -- your changes will be LOST!"
}

/^CLASS/ {
  classname=$2
  wrote_include=0
  context=1
  if ($3 == "EXTENDS") {
    if (NF < 4) {
      print "Missing classname(s) in line " FNR
      exit 1
    }
    for (k = 4; k <= NF; k++) {
      split(superclass_functions[$k], funcnames, ",")
      for (i in funcnames) {
        funcname=funcnames[i]
        if (funcname != "") {
          argcount=superclass[$k, funcname, "argcount"]
          delete args
          for (j = 0; j <= argcount; j++) {
            args[j]=superclass[$k, funcname, j]
          }
          print_function_body(superclass[$k, funcname, "rettype"],
              funcname, args, argcount);
        }
      }
    }
  }
}

/^SUPERCLASS/ {
  context=2
  classname=$2
  if ($3 == "EXTENDS") {
    for (k = 4; k <= NF; k++) {
      superclass_functions[$2]=superclass_functions[$k]
      if (superclass_functions[$2] == "") {
        print "Erroneous SUPERCLASS .. EXTENDS construct in line " FNR
        exit 1
      }
      split(superclass_functions[$k], funcnames, ",")
      for (i in funcnames) {
        funcname=funcnames[i]
        if (funcname != "") {
          argcount=superclass[$k, funcname, "argcount"]
          for (j = 0; j <= argcount; j++) {
            superclass[$2, funcname, j]=superclass[$k, funcname, j]
          }
          superclass[$2, funcname, "argcount"]=argcount
          superclass[$2, funcname, "rettype"]=superclass[$k, funcname, "rettype"]
        }
      }
    }
  }
}

/^DEFTYPE/ {
  baseclass[$2]=$3
  allowed_class[$2]=(NF-2)
  for (i = 3; i <= NF; i++) {
    allowed_class[$2] = allowed_class[$2] ", \"" $i "\""
  }
}

/^DEFSIMPLE/ {
  for (i = 2; i <= NF; i++) {
    baseclass[$i]=$i
    allowed_class[$i]="1, \"" $i "\""
  }
}

context == 2 && /^FUNC/ {
  superclass_functions[classname]=superclass_functions[classname] "," $3
  superclass[classname, $3, "rettype"]=$2
  superclass[classname, $3, "argcount"]=(NF - 4)
  for (i = 4; i <= NF; i++) {
    j=(i-4)
    superclass[classname, $3, j]=$i
  }
  next
}

context == 1 && /^FUNC/ {
  for (i = 4; i <= NF; i++) {
    args[i - 4]=$i
  }
  print_function_body($2, $3, args, NF - 4)
  delete args
  next
}

/^ENDCLASS/ {
}

/^ENDSUPERCLASS/ {
}
